
Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,0,60,-15
RotateEntity light01,30,0,0
AmbientLight 255,255,255


;Plane
plane=CreatePlane()
EntityColor plane,100,200,100

;Camera
Global cam=CreateCamera()
PositionEntity cam,0,35,-55
RotateEntity cam,30,0,0


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")					
pxSetGravity(0,-10,0)				

		stena_body=PxBodyCreateCube(50,50,1, 0)
		pxBodySetPosition(stena_body, 0,20,30)
 		stena_mesh=CreateCube()
		ScaleEntity stena_mesh,50,50,1
		EntityColor stena_mesh,Rand(0,255),Rand(0,255),Rand(0,255)


		cube_body=PxBodyCreateCube(6,7,6, 10)
		pxBodySetPosition(cube_body, 0,10,0)
 		cube_mesh=CreateCube()
		ScaleEntity cube_mesh,6,7,6
		EntityColor cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
		EntityAlpha cube_mesh,0.0

;Cloth Mesh
cloth_mesh = LoadMesh ("..\media\barel.b3d")
ScaleMesh cloth_mesh,15,15,15
;PositionEntity cloth_mesh,0,30,0
EntityFX cloth_mesh,16
MeshHeight (cloth_mesh)
surf = GetSurface (cloth_mesh,1 )
cloth1_body = pxCreateMetalCloth(cloth_mesh, surf, cube_body, 40, 1.0)

;cloth Core
		core_body=pxBodyCreateCylinder(6,7, 12, 10)
		pxBodySetPosition(core_body, 0,60,0)
 		core_mesh=CreateCube()
		ScaleEntity core_mesh,6,7,6
		EntityColor core_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
		EntityAlpha core_mesh,0.0

;create MetalCloth
cloth1_mesh = LoadMesh ("..\media\barel.b3d")
ScaleMesh cloth1_mesh,15,15,15
PositionEntity cloth1_mesh,0,30,0
EntityFX cloth1_mesh,16
MeshHeight (cloth1_mesh)
surf1 = GetSurface (cloth1_mesh,1 )
cloth3_body = pxCreateMetalCloth(cloth1_mesh, surf1, core_body, 40, 1.0)

WireFrame 0
Repeat

If KeyHit(57) Create_Px_Cube()

x#=0: y#=0: z#=0 
If KeyDown( 203 )=True Then x#=-0.2 
If KeyDown( 205 )=True Then x#=0.2 
If KeyDown( 208 )=True Then y#=-0.2 
If KeyDown( 200 )=True Then y#=0.2 
If KeyDown( 44 )=True Then z#=-0.2 
If KeyDown( 30 )=True Then z#=0.2 

MoveEntity cam,x#,y#,z#

time=MilliSecs ()
	pxUpdateCloth()
	Update_Px_Cube()
	pxBodySetEntity (cube_mesh, cube_body)
	pxBodySetEntity (core_mesh, core_body)
	pxBodySetEntity (stena_mesh, stena_body)
	pxRenderPhysic(30,0)		
New_time=MilliSecs ()-time


UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time

Flip 

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(1,1,1, 3)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,1,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, 0, 0, 150, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function