Print "1 - 800x600"
Print "2 - 1024x768"
Print "3 - 1280x1024"
Print "4 - 800x600 Windowed"
key = Input()
Print "Flip 0 or 1"
fl= Input()

If key=1 Graphics3D 800,600,32,1
If key=2 Graphics3D 1024,768,32,1
If key=3 Graphics3D 1280,1024,32,1
If key=4 Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,0,60,-15
RotateEntity light01,30,0,0
AmbientLight 255,255,255


;Plane
plane=CreatePlane()
EntityColor plane,100,200,100
EntityAlpha plane, 0.5
m=CreateMirror ()

;Camera
Global cam=CreateCamera()
PositionEntity cam,0,20,-25
RotateEntity cam,30,0,0


cloth_mesh1 = LoadMesh ("..\media\dolphin.x")
ScaleMesh cloth_mesh1,.02,.02,.02
surf1 = GetSurface (cloth_mesh1,1 )
PositionEntity cloth_mesh1,-20,15,0
EntityFX cloth_mesh1,16
tex=LoadTexture ("..\media\star.jpg")
ScaleTexture tex,0.1,0.1
EntityTexture cloth_mesh1, tex
EntityShininess cloth_mesh1, 1

cloth_mesh2 = LoadMesh ("..\media\fighter29.x")
ScaleMesh cloth_mesh2,5,5,5
surf2 = GetSurface (cloth_mesh2,1 )
PositionEntity cloth_mesh2,0,15,0
EntityFX cloth_mesh2,16
tex2=LoadTexture ("..\media\star.jpg")
EntityTexture cloth_mesh2, tex2
EntityShininess cloth_mesh2, 1

cloth_mesh3 = LoadMesh ("..\media\camel.x")
ScaleMesh cloth_mesh3,3,3,3
surf3 = GetSurface (cloth_mesh3,1 )
PositionEntity cloth_mesh3,23,15,0
EntityFX cloth_mesh3,16
tex3=LoadTexture ("..\media\star.jpg")
EntityTexture cloth_mesh3, tex3
EntityShininess cloth_mesh3, 1

;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")					
pxSetGravity(0,-10,0)				

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(40,2,2,0)
		pxBodySetPosition(ocu\cube_body, 0,15,20)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,40,2,2
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(3,3,3, 50)
		pxBodySetPosition(ocu\cube_body, -20,5,0)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,3,3,3
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(3,3,3, 50)
		pxBodySetPosition(ocu\cube_body, 0,5,0)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,3,3,3
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(3,3,3, 50)
		pxBodySetPosition(ocu\cube_body, 20,5,0)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,3,3,3
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)


cloth1_body = pxCreateCloth(cloth_mesh1, surf1)
pxClothSetPressure(cloth1_body, 3)

cloth2_body = pxCreateCloth(cloth_mesh2, surf2)
pxClothSetPressure(cloth2_body, 8)

cloth3_body = pxCreateCloth(cloth_mesh3, surf3)
pxClothSetPressure(cloth3_body, 3)


Repeat

If KeyHit(57) Create_Px_Cube()

x#=0: y#=0: z#=0 
If KeyDown( 203 )=True Then x#=-0.2 
If KeyDown( 205 )=True Then x#=0.2 
If KeyDown( 208 )=True Then y#=-0.2 
If KeyDown( 200 )=True Then y#=0.2 
If KeyDown( 44 )=True Then z#=-0.2 
If KeyDown( 30 )=True Then z#=0.2 

MoveEntity cam,x#,y#,z#

VertexCoords surf1,0, 0,0,0
MeshHeight (cloth_mesh1)
UpdateNormals cloth_mesh1
VertexCoords surf2,0, 0,0,0
MeshHeight (cloth_mesh2)
UpdateNormals cloth_mesh2
VertexCoords surf3,0, 0,0,0
MeshHeight (cloth_mesh3)
UpdateNormals cloth_mesh3
time=MilliSecs ()
	pxUpdateCloth()
	Update_Px_Cube()
	pxRenderPhysic(60,0)		
New_time=MilliSecs ()-time


If KeyHit( 2 )=True Then enable=1-enable 


UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time
Text 10,30,"surf: "+CountVertices (surf1)
Flip 
Until KeyHit(1)

End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(1,1,1, 3)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,1,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, 0, 0, 50, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function