Include "Ashadow.bb"

aGraphics3D 800,600,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateSLight()
PositionEntity light01,0,60,-15
RotateEntity light01,30,0,0
AmbientLight 255,255,255

;Plane
plane=ACreatePlane()
EntityColor plane,100,200,100
EntityAlpha plane, 0.5
m=CreateMirror ()

;Camera
Global cam=CreateCamera()
PositionEntity cam,0,35,-55
RotateEntity cam,30,0,0

tex = LoadTexture ("Logo.jpg")
;---------- Create Cloth Meshes----------
cloth_mesh1 = ALoadMesh ("pol.b3d")
EntityTexture cloth_mesh1,tex
;RotateMesh cloth_mesh1,-90,0,0
PositionEntity cloth_mesh1,30,30,0
EntityFX cloth_mesh1,16
MeshHeight (cloth_mesh1)
surf1 = GetSurface (cloth_mesh1,1 )

cloth_mesh2 = LoadMesh ("pol.b3d")
EntityTexture cloth_mesh2,tex
PositionEntity cloth_mesh2,-30,30,0
EntityFX cloth_mesh2,16
MeshHeight (cloth_mesh2)
surf2 = GetSurface (cloth_mesh2,1 )

cloth_mesh3 = LoadMesh ("pol.b3d")
EntityTexture cloth_mesh3,tex
PositionEntity cloth_mesh3,0,30,0
EntityFX cloth_mesh3,16
MeshHeight (cloth_mesh3)
surf3 = GetSurface (cloth_mesh3,1 )


;PX
Scene = pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
If (Scene = 0) RuntimeError "Scene dont creat"
pxSetGravity(0,-10,0)				


 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(12,1,2, 0)
		pxBodySetPosition(ocu\cube_body, 30,30,10)
 		ocu\cube_mesh=ACreateCube()
		ScaleEntity ocu\cube_mesh,12,1,2
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

		cube1 = ocu\cube_body

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(12,1,1, 15)
		pxBodySetPosition(ocu\cube_body, 30,30,-10)
 		ocu\cube_mesh=ACreateCube()
		ScaleEntity ocu\cube_mesh,12,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

		cube2 = ocu\cube_body

;------------ Create cloth--------------------------
cloth1_body = pxCreateCloth(cloth_mesh1, surf1)
cloth2_body = pxCreateCloth(cloth_mesh2, surf2)
cloth3_body = pxCreateCloth(cloth_mesh3, surf3)

;---------------- Attach Cloth---------------------
pxClothAttachVertexToPos (cloth3_body, 399, -10,30,10)
pxClothAttachVertexToPos (cloth3_body, 440, 9,30,10)

pxClothAttachVertexToPos (cloth2_body, 399, -39,30,10)
pxClothAttachVertexToPos (cloth2_body, 440, -21,30,10)
pxClothAttachVertexToPos (cloth2_body, 1, -39,20,-8)
pxClothAttachVertexToPos (cloth2_body, 40, -21,20,-8)


pxClothSetAttachmentTearFactor(cloth1_body, 2)
pxClothAttachToShape(cloth1_body, cube1, 1)
pxClothAttachToShape(cloth1_body, cube2, 0)

pxClothSetBendingStiffness (cloth3_body, 1)
pxClothSetBendingStiffness (cloth1_body, 1)



Repeat

If KeyHit(57) pxClothDetachFromShape(cloth1_body, cube1)

x#=0: y#=0: z#=0 
If KeyDown( 203 ) Then x#=-0.2 
If KeyDown( 205 ) Then x#=0.2 
If KeyDown( 208 ) Then y#=-0.2 
If KeyDown( 200 ) Then y#=0.2 
If KeyDown( 44 ) Then z#=-0.2 
If KeyDown( 30 ) Then z#=0.2
If KeyDown( 2 ) Then ry = ry+1
If KeyDown( 3 ) Then ry = ry-1 
RotateEntity cam,0,ry,0

MoveEntity cam,x#,y#,z#

time=MilliSecs ()
;-------Update cloth and World-------
	pxUpdateCloth()
	Update_Px_Cube()
	pxRenderPhysic(30,0)		
New_time=MilliSecs ()-time



UpdateWorld()
UpdateShadows(cam)
RenderShadows(cam)

   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time

Flip 

Until KeyHit(1)
pxDestroyWorld()
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(1,1,1, 3)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,1,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, 0, 0, 50, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function