Graphics3D 800, 600, 32, 2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0,capsule

pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0, -10, 0)


camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,0,20,-40
RotateEntity camera,30,0,0

plane=CreatePlane( )
EntityColor plane,0,100,200
EntityAlpha plane,0.5

mir = CreateMirror ()


;============== create compound mesh ===============
comp_mesh = CreateCube()
ScaleEntity comp_mesh, 1,1,1
PositionMesh comp_mesh, -4,0,0

comp_cyl_mesh = CreateCylinder()
ScaleMesh comp_cyl_mesh, 1,2,1
PositionMesh comp_cyl_mesh, -2,0,0
AddMesh comp_cyl_mesh , comp_mesh
FreeEntity comp_cyl_mesh

comp_sp_mesh = CreateSphere()
PositionMesh comp_sp_mesh, 0,0,0
AddMesh comp_sp_mesh , comp_mesh
FreeEntity comp_sp_mesh

comp_cap_mesh =  Mesh_Capsule(0.5, 6)
PositionMesh comp_cap_mesh, 2,0,0
AddMesh comp_cap_mesh , comp_mesh
FreeEntity comp_cap_mesh

;============== create compound body ===============
comp_desc = pxCreateCompoundDesc()

comp_cube_shape = pxCompoundAddCubeShape(comp_desc, 1, 1, 1)
pxCompoundSetShapePos (comp_cube_shape, -4,0,0)
pxCompoundSetShapeRot (comp_cube_shape, 0,0,0)

comp_cyl_shape = pxCompoundAddCylinderShape(comp_desc, 1, 2, 8)
pxCompoundSetShapePos (comp_cyl_shape, -2,0,0)
pxCompoundSetShapeRot (comp_cyl_shape, 0,0,0)

comp_sp_shape = pxCompoundAddSphereShape(comp_desc, 1)
pxCompoundSetShapePos (comp_sp_shape, 0,0,0)

comp_cap_shape = pxCompoundAddCapsuleShape(comp_desc, 0.5, 6)
pxCompoundSetShapePos (comp_cap_shape, 2,0,0)
pxCompoundSetShapeRot (comp_cap_shape, 0,0,00)

comp_body = pxCreateCompound(comp_desc, 2)
pxBodySetPosition(comp_body ,0,5,0)
;============== END ===============


cu = pxBodyCreateCube( 1, 1, 1,  1)
pxBodySetPosition(cu,0,10,0)
cu_mesh = CreateCube()


While Not KeyDown( 1 )


If KeyHit(57)
	Create_Px_Compound()
	k=k+1
EndIf  

time=MilliSecs ()
	pxRenderPhysic(60,0)
	Update_Px_Compound()
New_time=MilliSecs ()-time

pxBodySetEntity(comp_mesh, comp_body)
pxBodySetEntity(cu_mesh , cu)


UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,20,"amount: "+k
  Text 10,30,"Space - add Compound " 


Flip 
Wend 

End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type



 Function Create_Px_Compound()
   ocu.Px_Cube = New Px_Cube

	;============== create compound body ===============
	comp_desc = pxCreateCompoundDesc()

	pos_x# = Rnd#(-3,3): pos_y# = Rnd#(-3,3):  pos_z# = Rnd#(-3,3)
	rot_x# = Rnd#(-180,180): rot_y# = Rnd#(-180,180): rot_z# = Rnd#(-180,180)
	
	comp_cube_shape = pxCompoundAddCubeShape(comp_desc, 1, 1, 1)
	pxCompoundSetShapePos (comp_cube_shape, pos_x#, pos_y#, pos_z#)
	pxCompoundSetShapeRot (comp_cube_shape, rot_x#, rot_y#, rot_z#)
		ocu\cube_mesh = CreateCube()
	EntityColor ocu\cube_mesh,Rand(0,255), Rand(0,255), Rand(0,255)
	ScaleEntity ocu\cube_mesh, 1,1,1
	RotateMesh ocu\cube_mesh, rot_x, rot_y, rot_z
	PositionMesh ocu\cube_mesh, pos_x, pos_y, pos_z

	pos_x# = Rnd#(-3,3): pos_y# = Rnd#(-3,3):  pos_z# = Rnd#(-3,3)
	rot_x# = Rnd#(-180,180): rot_y# = Rnd#(-180,180): rot_z# = Rnd#(-180,180)
	
	comp_cyl_shape = pxCompoundAddCylinderShape(comp_desc, 1, 2, 8)
	pxCompoundSetShapePos (comp_cyl_shape, pos_x, pos_y, pos_z)
	pxCompoundSetShapeRot (comp_cyl_shape, rot_x#, rot_y#, rot_z#)
		comp_cyl_mesh = CreateCylinder()
		EntityColor ocu\cube_mesh,Rand(0,255), Rand(0,255), Rand(0,255)
	ScaleMesh comp_cyl_mesh, 1,2,1
	RotateMesh comp_cyl_mesh, rot_x, rot_y, rot_z
	PositionMesh comp_cyl_mesh, pos_x, pos_y, pos_z
	AddMesh comp_cyl_mesh , ocu\cube_mesh
	FreeEntity comp_cyl_mesh

	pos_x# = Rnd#(-3,3): pos_y# = Rnd#(-3,3):  pos_z# = Rnd#(-3,3)
	rot_x# = Rnd#(-180,180): rot_y# = Rnd#(-180,180): rot_z# = Rnd#(-180,180)
		
	comp_sp_shape = pxCompoundAddSphereShape(comp_desc, 1)
	pxCompoundSetShapePos (comp_sp_shape, pos_x, pos_y, pos_z)
		comp_sp_mesh = CreateSphere()
		EntityColor comp_sp_mesh,Rand(0,255), Rand(0,255), Rand(0,255)
	PositionMesh comp_sp_mesh, pos_x, pos_y, pos_z
	AddMesh comp_sp_mesh , ocu\cube_mesh
	FreeEntity comp_sp_mesh

	pos_x# = Rnd#(-3,3): pos_y# = Rnd#(-3,3):  pos_z# = Rnd#(-3,3)
	rot_x# = Rnd#(-180,180): rot_y# = Rnd#(-180,180): rot_z# = Rnd#(-180,180)
	
	comp_cap_shape = pxCompoundAddCapsuleShape(comp_desc, 0.5, 6)
	pxCompoundSetShapePos (comp_cap_shape, pos_x, pos_y, pos_z)
	pxCompoundSetShapeRot (comp_cap_shape, rot_x#, rot_y#, rot_z#)
		comp_cap_mesh =  Mesh_Capsule(0.5, 6)
	EntityColor comp_cap_mesh,Rand(0,255), Rand(0,255), Rand(0,255)
	RotateMesh comp_cap_mesh, rot_x, rot_y, rot_z
	PositionMesh comp_cap_mesh, pos_x, pos_y, pos_z
	AddMesh comp_cap_mesh ,ocu\cube_mesh
	FreeEntity comp_cap_mesh
	
	ocu\cube_body = pxCreateCompound(comp_desc, 2)
	;============== END ===============


     pxBodySetPosition(ocu\cube_body,Rand(-20,20),40,Rand(-10,30))
	 pxBodySetRotation(ocu\cube_body,Rand(-50,50),Rand(-50,50),Rand(-50,50))

 End Function

Function Update_Px_Compound()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function Mesh_Capsule(radius#, height#)
 ;------------------------create Mesh-------------

capsule= CreateCylinder()
ScaleMesh capsule, radius, height/2, radius
PositionMesh capsule,0,0,0

sphere1 = CreateSphere() 
ScaleMesh sphere1,radius,radius,radius
PositionMesh sphere1,0, height/2,0
AddMesh sphere1,capsule

sphere2 = CreateSphere() 
ScaleMesh sphere2,radius,radius,radius
PositionMesh sphere2,0, -height/2,0
AddMesh sphere2,capsule

FreeEntity sphere1
FreeEntity sphere2

HideEntity capsule
Return capsule
;----------------------------------------------------------------
 End Function
