
Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,0,60,-15
RotateEntity light01,30,0,0
AmbientLight 255,255,255


;Plane
plane=CreatePlane()
EntityColor plane,100,200,100
EntityAlpha plane, 0.5
m=CreateMirror ()

;Camera
Global cam=CreateCamera()
PositionEntity cam,0,45,-55
RotateEntity cam,30,0,0


tex = LoadTexture ("logo.jpg")
cloth_mesh1 = LoadMesh ("pol.b3d")
EntityTexture cloth_mesh1,tex
PositionEntity cloth_mesh1,-20,50,0
EntityFX cloth_mesh1,16
MeshHeight (cloth_mesh1)
surf1 = GetSurface (cloth_mesh1,1 )
num_ver1 = CountTriangles (surf1)

cloth_mesh2 = LoadMesh ("carpet.b3d")
PositionEntity cloth_mesh2,0,36,0
EntityFX cloth_mesh2,16
MeshHeight (cloth_mesh2)
surf2 = GetSurface (cloth_mesh2,1 )

cloth_mesh3 = LoadMesh ("carpet.b3d")
PositionEntity cloth_mesh3,25,36,0
EntityFX cloth_mesh3,16
MeshHeight (cloth_mesh3)
surf3 = GetSurface (cloth_mesh3,1 )

cloth_mesh4 = LoadMesh ("carpet.b3d")
PositionEntity cloth_mesh4,50,36,0
EntityFX cloth_mesh4,16
MeshHeight (cloth_mesh4)
surf4 = GetSurface (cloth_mesh4,1 )

cloth_mesh5 = LoadMesh ("carpet.b3d")
PositionEntity cloth_mesh5,-40,36,0
EntityFX cloth_mesh5,16
MeshHeight (cloth_mesh5)
surf5 = GetSurface (cloth_mesh5,1 )



;PX
Mode%=Input("Hardware 0 or 1 :     ")

pxSetHardwareSimulation(Mode)
pxCreateWorld(1,"{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0,-10,0)				

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(12,1,2, 0)
		pxBodySetPosition(ocu\cube_body, -20,50,10)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,12,1,2
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(2,2,2, 30)
		pxBodySetPosition(ocu\cube_body, -10,50,0)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,2,2,2
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(25,1,2, 0)
		pxBodySetPosition(ocu\cube_body, 20,50,0)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,25,1,2
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

 ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(2,2,2, 180)
		pxBodySetPosition(ocu\cube_body, 30,38,0)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,2,2,2
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 

; Cloth 1
cloth1_body = pxCreateTearableCloth(cloth_mesh1, surf1)
pxClothSetBending(cloth1_body)
pxClothSetTearFactor(cloth1_body, 1.4)
pxClothAttachToCollidingShapes(cloth1_body,1)

; Cloth 2
cloth2_body = pxCreateTearableCloth(cloth_mesh2, surf2)
pxClothSetTearFactor(cloth2_body, 2.2)
pxClothAttachToCollidingShapes(cloth2_body,1)

; Cloth 3
cloth3_body = pxCreateTearableCloth(cloth_mesh3, surf3)
pxClothSetTearFactor(cloth3_body, 2.2)
pxClothAttachToCollidingShapes(cloth3_body,1)

; Cloth 4
cloth4_body = pxCreateTearableCloth(cloth_mesh4, surf4)
pxClothSetTearFactor(cloth4_body, 2.2)
pxClothAttachToCollidingShapes(cloth4_body,1)

; Cloth 5
cloth5_body = pxCreateTearableCloth(cloth_mesh5, surf5)
pxClothSetTearFactor(cloth5_body, 2.2)
pxClothAttachToCollidingShapes(cloth5_body,1)

Repeat

x#=0: y#=0: z#=0 

If KeyDown( 203 )=True Then x#=-0.2 
If KeyDown( 205 )=True Then x#=0.2 
If KeyDown( 208 )=True Then y#=-0.2 
If KeyDown( 200 )=True Then y#=0.2 
If KeyDown( 44 )=True Then z#=-0.2 
If KeyDown( 30 )=True Then z#=0.2

MoveEntity cam,x#,y#,z#

	time=MilliSecs ()
If KeyHit (57)
Create_Px_Cube()

 EndIf
	pxUpdateCloth()
	Update_Px_Cube()
	pxRenderPhysic(30,0)
	New_time=MilliSecs ()-time

MeshHeight (cloth_mesh2)


UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time
  Text 10,20,"PPU: "+ pxChekPPU%()
  Text 10,30,"PPU Mode: "+ pxChekPPUMode%()
Flip 

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(1,1,1, 50)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,1,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, 0, 0, 50, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function