
Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

Global StarAmount, SparcleAmount

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

m=CreateMirror ()


;Camera
cam=CreateCamera()
PositionEntity cam,0,45,-48
RotateEntity cam,30,0,0


;Cube
cube=CreateCube()
ScaleEntity cube,2,2,2
text02=LoadTexture("..\media\cube.jpg")
EntityTexture cube,text02


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0,-10,0)	

;Physic cube
cube_body=pxBodyCreateCube(2,2,2,100)	
pxBodySetPosition cube_body,10,15,0	
pxBodySetCollisionGroup(cube_body, 1)

Global pEmitter = pxParticleCreateEmitter%()
pxParticleEmitSetStartSpeed( pEmitter, 15, 18)
pxParticleEmitSetPosition(pEmitter, 0, 20,0)
pxParticleEmitSetRotation( pEmitter, 0, 0, -40)

Global SparcleEmitter = pxParticleCreateEmitter%()
pxParticleEmitSetStartSpeed( SparcleEmitter, 10, 20)
pxParticleEmitSetPosition(SparcleEmitter, 0, 0,0)
pxParticleEmitSetTDAcceleration(SparcleEmitter, 0, -9, 0)
pxParticleEmitSetRandRadius(SparcleEmitter, 5)


Repeat ;Main Loop

yaw = yaw+1
pxParticleEmitSetRotation( pEmitter, 0, yaw, 50)
pxParticleEmitSetPosition(SparcleEmitter, 20*Sin(0.03*MilliSecs ()), 0,20*Cos(0.03*MilliSecs ()))

 CreateParticleStar()
 CreateParticleSparcle()


time=MilliSecs ()
pxRenderPhysic(30,0)
pxParticleUpdateEmitter(pEmitter)
pxParticleUpdateEmitter(SparcleEmitter)
pxBodySetEntity(cube,cube_body)
UpdateParticleStar()
UpdateParticleSparcle()
New_time=MilliSecs ()-time

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
  Text 10,20,StarAmount
Flip 

Until KeyHit(1)
End



;Star
Type Particle_Star
	Field particle
	Field sprite
End Type

 Function CreateParticleStar()
  ps.Particle_Star = New Particle_Star
 	ps\sprite = LoadSprite("..\media\star.png",2)
  	ps\particle = pxParticleEmitAddParticle(pEmitter, ps\sprite)
	StarAmount = StarAmount+1
End Function

Function UpdateParticleStar()
For ps.Particle_Star = Each Particle_Star
	If StarAmount>250
	  	entit = pxParticleEmitDeleteFirstParticle(pEmitter)
		FreeEntity Entit
		Delete ps
		StarAmount = StarAmount - 1
	  EndIf
Next
End Function

;Sparcle
Type Particle_Sparcle
	Field particle
	Field sprite
End Type

 Function CreateParticleSparcle()
  psp.Particle_Sparcle= New Particle_Sparcle
 	psp\sprite = LoadSprite("..\media\Bigspark.BMP")
	;ScaleSprite psp\sprite, 2, 2
  	psp\particle = pxParticleEmitAddParticle(SparcleEmitter, psp\sprite)
	SparcleAmount = SparcleAmount+1
End Function

Function UpdateParticleSparcle()
For psp.Particle_Sparcle = Each Particle_Sparcle
	If SparcleAmount>150
	  	entit = pxParticleEmitDeleteFirstParticle(SparcleEmitter)
		FreeEntity Entit
		Delete psp
		SparcleAmount = SparcleAmount - 1
	  EndIf
Next
End Function