Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

Global StarAmount

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
EntityColor plane,0,0,150

;Camera
cam=CreateCamera()
PositionEntity cam,-40,40,-48
RotateEntity cam,0,-40,0


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")			
pxSetGravity(0,-10,0)		

;Physic cube
cube=CreateCube()
ScaleEntity cube,5,1,5
text02=LoadTexture("..\media\cube.jpg")
EntityTexture cube,text02
cube_body=pxBodyCreateCube(5,1,5,0)	
pxBodySetPosition cube_body,0,15,0	
pxBodySetRotation cube_body,0,0,-30	
pxBodySetCollisionGroup(cube_body, 1)

Global pEmitter = pxParticleCreateEmitter%()
pxParticleEmitSetRadius(pEmitter, 0.5)
pxParticleEmitSetStartSpeed( pEmitter, 3, 5)
pxParticleEmitSetTDAcceleration(pEmitter, 3, 3, 0)
pxParticleEmitSetRandRadius( pEmitter, 3)
pxParticleEmitSetScaleFactor(pEmitter, 3, .5)




Repeat

	n=1-n
	If n=1 CreateParticleStar()
	
	time=MilliSecs ()
	
	pxRenderPhysic(30,0)
	pxParticleUpdateEmitter(pEmitter)
	
	pxBodySetEntity(cube,cube_body)
	
	UpdateParticleStar()
	New_time=MilliSecs ()-time

	UpdateWorld()
	RenderWorld()
	
		frames=frames+1  
		If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
		Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
		Text 10,20,StarAmount
		
	Flip 

Until KeyHit(1)
End


Type Particle_Star
	Field particle
	Field sprite
End Type

Function CreateParticleStar()
  	ps.Particle_Star = New Particle_Star
	 	ps\sprite = LoadSprite("..\media\smoke.jpg",2)
		SpriteViewMode ps\sprite,3
	  	ps\particle = pxParticleEmitAddParticle(pEmitter, ps\sprite)
		StarAmount = StarAmount+1
End Function

Function UpdateParticleStar()
	For ps.Particle_Star = Each Particle_Star
		radius# = pxParticleGetradius#(ps\particle)
		ScaleSprite ps\sprite, radius, radius
		If StarAmount>100
		  	entit = pxParticleEmitDeleteFirstParticle(pEmitter)
			FreeEntity Entit
			Delete ps
			StarAmount = StarAmount - 1
		  EndIf
	Next
End Function