Graphics3D 640,480,32,2
SetBuffer BackBuffer()

;light
light=CreateLight(1)
PositionEntity light,0,50,20

;cam
campiv=CreatePivot()

cam=CreateCamera()
PositionEntity cam,0,17,-25
PointEntity cam,campiv
EntityParent cam,campiv

;plane
plane=CreatePlane()
tile1=LoadTexture("media\tile.jpg")
ScaleTexture tile1,5,5
EntityTexture plane,tile1

sp = CreateSphere ()
EntityColor sp,0,255,0
ScaleEntity sp,0.4,0.4,0.4

;physX
pxCreateWorld(1, "key")
pxSetGravity(0,-10,0)

;cube physic
xcubic=pxBodyCreateCube(2,2,2,1)
pxBodySetPosition(xcubic,0,6,0)
cubic=CreateCube()
ScaleEntity cubic,2,2,2
tile2=LoadTexture("media\cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic,tile2

;cube physic
xcubic1=pxBodyCreateCube(2, 2, 2, 1)
pxBodySetPosition(xcubic1,0,2.5,0)
cubic1=CreateCube()
ScaleEntity cubic1,2,2,2
tile2=LoadTexture("media\cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic1,tile2

;cube physic
xcubic2=pxBodyCreateCube(2, 2, 2, 1)
pxBodySetPosition(xcubic2,5,5,0)
cubic2=CreateCube()
ScaleEntity cubic2,2,2,2
tile2=LoadTexture("media\cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic2,tile2

xang# = 0
yang# = 0
zang# = 0

;Ray
Ray = pxCreateRay()
pxRaySetDir(ray, 0, -1, 1)
pxRaySetPosition(ray, 0, 10, 0)

;Ray mesh
ray_m = CreateCylinder ()
PositionMesh ray_m,0,1,0
ScaleEntity ray_m,.1,5,.1


Repeat

If KeyDown (205) x# = x+.1
If KeyDown (203) x# = x-.1
If KeyDown (200) z# = z+.1
If KeyDown (208) z# = z-.1

PositionEntity ray_m, x,0,z
pxRaySetPosition(ray, x, 10, z)

PositionEntity sp,pxRayGetPickX(ray,0),pxRayGetPickY(ray,0),pxRayGetPickZ(ray,0)

;physic
pxRenderPhysic(30,0)

pxBodySetEntity(cubic,xcubic)
pxBodySetEntity(cubic1,xcubic1)
pxBodySetEntity(cubic2,xcubic2)


If KeyDown (57)
	body  = pxRayGetBody(ray, 1)
	If body pxBodyAddForce(body, 0,20,0, 0)
EndIf

UpdateWorld()
RenderWorld()
Text 5,25, "Arrow - control ray  "
Text 5,45, "Space - Add Force  "
Flip
Until KeyHit(1)
End
;~IDEal Editor Parameters:
;~C#Blitz3D