Print "1 - 800x600"
Print "2 - 1024x768"
Print "3 - 1280x1024"
Print "4 - 800x600 Windowed"
key = Input()
Print "VSinc 0 or 1"
fl= Input()

If key=1 Graphics3D 800,600,32,1
If key=2 Graphics3D 1024,768,32,1
If key=3 Graphics3D 1280,1024,32,1
If key=4 Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

Global n#,k=0,w=1.1 ,sp, mvbank

Global cam=CreateCamera() 
light=CreateLight()
PositionEntity cam,10,100,-120
RotateEntity cam,10,0,0

plane=CreatePlane( )
EntityColor plane,0,100,200



PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

funny_model = LoadAnimMesh("media\funny_model.b3d")
ScaleEntity funny_model,1,1,1
PositionEntity funny_model,0,100,0
RotateEntity funny_model,0,80,0
Animate funny_model, 1, 0.2
head = FindChild (funny_model, "Sphere01")

mesh = LoadMesh ("media\hat.b3d")
FlipMesh mesh
surf= GetSurface (mesh,1)
mvn=CountVertices (surf)
mvbank = CreateBank(nvert*4*3)
mvbank = GetVertBank(mesh)

SB = pxCreateSoftBody("media\hat.obj", "media\hat.tet", mvbank, mvn, 0, 100, 0,  0,0,0)
pxSoftBodySetStretchingStiffness(SB%, 0.2)


sp_body = pxBodyCreateSphere(16, 10)
pxBodySetPosition(sp_body,EntityX(head, 1), EntityY(head, 1), EntityZ(head, 1))
pxSoftBodyAttachToCollidingShapes(SB%, 0)
pxKinematicSet(sp_body)


While Not KeyDown( 1 )

x#=0
y#=0
z#=0
If KeyDown( 203 ) Then x#=-0.2 
If KeyDown( 205 ) Then x#=0.2 
If KeyDown( 208 ) Then y#=-0.2 
If KeyDown( 200 ) Then y#=0.2 
If KeyDown( 44 ) Then z#=-0.2 
If KeyDown( 30 ) Then z#=0.2
If KeyDown( 2 ) Then ry = ry+1
If KeyDown( 3 ) Then ry = ry-1

MoveEntity cam,x#,y#,z#

pxKinematicSetPosition(sp_body, EntityX(head, 1), EntityY(head, 1), EntityZ(head, 1))
pxKinematicSetRotation(sp_body, EntityPitch(head, 1), EntityYaw(head, 1), EntityRoll(head, 1))


time=MilliSecs ()
pxRenderPhysic(60,0)
pxUpdateSoftBody(SB)
UpdateSoftBody(mesh%, SB%)
New_time=MilliSecs ()-time


UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
  Text 10,20,"Space - add soft Body"
  Text 10,40,"Arrow/A/Z - Move Camera"
Flip fl
Wend 

End

Function GetVertBank%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Return vbank
End Function

Function UpdateSoftBody(mesh%, SoftBody%)

	Local nvert = 0
	Local surf= GetSurface (mesh,1)
	nvert=CountVertices (surf)
	vbank=CreateBank(nvert*4*3)
	nbank=CreateBank(nvert*4*3)
	pxSoftBodyGetVertexPos(SoftBody, vbank, nvert)
	pxSoftBodyGetNormals(SoftBody, nbank, nvert)
	
	nvc=0
	For nvc = 0 To nvert - 1
		VertexCoords (surf, nvc, PeekFloat (vbank, nvc*12+0), PeekFloat(vbank, nvc*12+4), PeekFloat(vbank, nvc*12+8))
		VertexNormal (surf, nvc, PeekFloat (nbank, nvc*12+0), PeekFloat(nbank, nvc*12+4), PeekFloat(nbank, nvc*12+8))
	Next
	FreeBank vbank
	FreeBank nbank
End Function

