Print "1 - 800x600"
Print "2 - 1024x768"
Print "3 - 1280x1024"
Print "4 - 800x600 Windowed"
key = Input()
Print "VSinc 0 or 1"
fl= Input()

If key=1 Graphics3D 800,600,32,1
If key=2 Graphics3D 1024,768,32,1
If key=3 Graphics3D 1280,1024,32,1
If key=4 Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

Global n#,k=0,w=1.1 ,sp, mvbank

Global cam=CreateCamera() 
light=CreateLight()
PositionEntity cam,10,40,-60
RotateEntity cam,10,0,0

plane=CreatePlane( )
EntityColor plane,0,100,200



PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

mesh = LoadMesh ("media\teapot.b3d")
FlipMesh mesh
surf= GetSurface (mesh,1)
mvn=CountVertices (surf)
mvbank = CreateBank(nvert*4*3)
mvbank = GetVertBank(mesh)

SB = pxCreateSoftBody("media\teapot.obj", "media\teapot_SB.tet", mvbank, mvn, 0, 60, 0,  0,0,0)
pxSoftBodySetStretchingStiffness(SB%, 0.01)

;sp_mesh = CreateSphere ()
;ScaleEntity sp_mesh,7,7,7
sp_body = pxBodyCreateSphere(7, 30)
pxBodySetPosition(sp_body,0, 60, 0)
pxSoftBodyAttachToShape(SB%, sp_body%)


cube = CreateCube ()
ScaleEntity cube,8,8,8
cube_body = pxBodyCreateCube(8,8,8,10)
pxBodySetPosition(cube_body,0,8,0)
;pxBodySetRotation(cube_body,-30,0,0)



While Not KeyDown( 1 )

If KeyHit (57) Create_SB(): k = k+1
If KeyHit(2) Create_Px_Cube()

x#=0
y#=0
z#=0
If KeyDown( 203 ) Then x#=-0.2 
If KeyDown( 205 ) Then x#=0.2 
If KeyDown( 208 ) Then y#=-0.2 
If KeyDown( 200 ) Then y#=0.2 
If KeyDown( 44 ) Then z#=-0.2 
If KeyDown( 30 ) Then z#=0.2
If KeyDown( 2 ) Then ry = ry+1
If KeyDown( 3 ) Then ry = ry-1

MoveEntity cam,x#,y#,z#

time=MilliSecs ()
pxRenderPhysic(60,0)
pxUpdateSoftBody(SB)
UpdateSoftBody(mesh%, SB%)
Update_SB()
Update_Px_Cube()
New_time=MilliSecs ()-time

pxBodySetEntity(cube, cube_body)
;pxBodySetEntity(sp_mesh, sp_body)

UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
  Text 10,20,"Space - add soft Body"
  Text 10,30,"1 - add Cube"+k
  Text 10,40,"Arrow/A/Z - Move Camera"
Flip fl
Wend 

End

Function GetVertBank%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Return vbank
End Function

Function UpdateSoftBody(mesh%, SoftBody%)

	Local nvert = 0
	Local surf= GetSurface (mesh,1)
	nvert=CountVertices (surf)
	vbank=CreateBank(nvert*4*3)
	nbank=CreateBank(nvert*4*3)
	pxSoftBodyGetVertexPos(SoftBody, vbank, nvert)
	pxSoftBodyGetNormals(SoftBody, nbank, nvert)
	
	nvc=0
	For nvc = 0 To nvert - 1
		VertexCoords (surf, nvc, PeekFloat (vbank, nvc*12+0), PeekFloat(vbank, nvc*12+4), PeekFloat(vbank, nvc*12+8))
		VertexNormal (surf, nvc, PeekFloat (nbank, nvc*12+0), PeekFloat(nbank, nvc*12+4), PeekFloat(nbank, nvc*12+8))
	Next
	FreeBank vbank
	FreeBank nbank
End Function


Type Px_SoftBody
	Field SB_body%
	Field SB_mesh%
End Type

Function Create_SB()
   ocu.Px_SoftBody = New Px_SoftBody
 		ocu\SB_mesh= LoadMesh ("media\teapot.b3d")
		surf= GetSurface (ocu\SB_mesh,1)
		mvn=CountVertices (surf)
		FlipMesh ocu\SB_mesh

		ocu\SB_body = pxCreateSoftBody("media\teapot.obj", "media\teapot_SB.tet", mvbank, mvn, 0, 60, 0,  0,0,0)
		EntityColor ocu\SB_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

		sp_body = pxBodyCreateSphere(7, 30)
		pxBodySetPosition(sp_body,0, 60, 0)
		pxSoftBodyAttachToShape(ocu\SB_body%, sp_body%)
 End Function

Function Update_SB()
	For ocu.Px_SoftBody = Each Px_SoftBody
		pxUpdateSoftBody(ocu\SB_body)
        UpdateSoftBody(ocu\SB_mesh, ocu\SB_body)
	Next
End Function

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(3,3,3, 3)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,3,3,3
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, 0, 0, 50, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function