Print "1 - 800x600"
Print "2 - 1024x768"
Print "3 - 1280x1024"
Print "4 - 800x600 Windowed"
key = Input()
Print "VSinc 0 or 1"
fl= Input()

If key=1 Graphics3D 800,600,32,1
If key=2 Graphics3D 1024,768,32,1
If key=3 Graphics3D 1280,1024,32,1
If key=4 Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

Global n#,k=0,w=1.1 ,sp, mvbank

Global cam=CreateCamera() 
light=CreateLight()
PositionEntity cam,10,100,-100
RotateEntity cam,20,0,0

plane=CreatePlane( )
EntityColor plane,0,100,200



PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

;      
mesh1 = LoadMesh ("media\bubble.b3d")
surf= GetSurface (mesh1,1)
mvn=CountVertices (surf)
mvbank = CreateBank(nvert*4*3)
mvbank = GetVertBank(mesh1)

SB1 = pxCreateSoftBody("media\bubble.obj", "media\bubble.tet", mvbank, mvn, 0, 60, 0,  0,0,0)

mesh2 = LoadMesh ("media\bubble.b3d")
SB2 = pxCreateSoftBody("media\bubble.obj", "media\bubble.tet", mvbank, mvn, -30, 90, 0,  0,0,-90)
pxSoftBodySetStretchingStiffness(SB2%, 0.05)

mesh3 = LoadMesh ("media\bubble.b3d")
SB3 = pxCreateSoftBody("media\bubble.obj", "media\bubble.tet", mvbank, mvn, 30, 90, 0,  0,0,90)
pxSoftBodySetStretchingStiffness(SB3%, 0.05)

mesh4 = LoadMesh ("media\bubble.b3d")
SB4 = pxCreateSoftBody("media\bubble.obj", "media\bubble.tet", mvbank, mvn, 0, 120, 0,  0,0,-180)
pxSoftBodySetStretchingStiffness(SB4%, 0.05)

mesh5 = LoadMesh ("media\bubble.b3d")
SB5 = pxCreateSoftBody("media\bubble.obj", "media\bubble.tet", mvbank, mvn, 0, 90, 30,  0,90,90)
pxSoftBodySetStretchingStiffness(SB5%, 0.05)

mesh6 = LoadMesh ("media\bubble.b3d")
SB6 = pxCreateSoftBody("media\bubble.obj", "media\bubble.tet", mvbank, mvn, 0, 90, -30,  0,90,-90)
pxSoftBodySetStretchingStiffness(SB6%, 0.05)

;   
EntityColor mesh1, 200,0,0
EntityColor mesh2, 200,0,0
EntityColor mesh3, 200,0,0
EntityColor mesh4, 200,0,0
EntityColor mesh5, 200,0,0
EntityColor mesh6, 200,0,0

FlipMesh mesh1
FlipMesh mesh2
FlipMesh mesh3
FlipMesh mesh4
FlipMesh mesh5
FlipMesh mesh6

pxSoftBodySetStretchingStiffness(SB1%, 0.05)
pxSoftBodySetStretchingStiffness(SB2%, 0.05)
pxSoftBodySetStretchingStiffness(SB3%, 0.05)
pxSoftBodySetStretchingStiffness(SB4%, 0.05)
pxSoftBodySetStretchingStiffness(SB5%, 0.05)
pxSoftBodySetStretchingStiffness(SB6%, 0.05)

;    
;   ,    ,  ,   
sp_mesh = CreateSphere ()
ScaleEntity sp_mesh,17,17,17
EntityColor sp_mesh, 0,200,0
sp_body = pxBodyCreateSphere(17, 20)
pxBodySetPosition(sp_body,0, 90, 0)

cap_body1 = pxBodyCreateCapsule%(14, 4, 10)
pxBodySetPosition(cap_body1, 0, 70, 0)

cap_body2 = pxBodyCreateCapsule%(14, 4, 10)
pxBodySetPosition(cap_body2, 0, 110, 0)

cap_body3 = pxBodyCreateCapsule%(14, 4, 10)
pxBodySetPosition(cap_body3, 20, 90, 0)
pxBodySetRotation(cap_body3, 0,0,90)

cap_body4 = pxBodyCreateCapsule%(14, 4, 10)
pxBodySetPosition(cap_body4, -20, 90, 0)
pxBodySetRotation(cap_body4, 0,0,-90)

cap_body5 = pxBodyCreateCapsule%(14, 4, 10)
pxBodySetPosition(cap_body5, 0, 90, -20)
pxBodySetRotation(cap_body5, 0,90,-90)

cap_body6 = pxBodyCreateCapsule%(14, 4, 10)
pxBodySetPosition(cap_body6, 0, 90, 20)
pxBodySetRotation(cap_body6, 0,90,90)

;     
pxAddBodytoBody(sp_body, cap_body1)
pxAddBodytoBody(sp_body, cap_body2)
pxAddBodytoBody(sp_body, cap_body3)
pxAddBodytoBody(sp_body, cap_body4)
pxAddBodytoBody(sp_body, cap_body5)
pxAddBodytoBody(sp_body, cap_body6)

;    
pxSoftBodyAttachToCollidingShapes(SB1, 0)
pxSoftBodyAttachToCollidingShapes(SB2, 0)
pxSoftBodyAttachToCollidingShapes(SB3, 0)
pxSoftBodyAttachToCollidingShapes(SB4, 0)
pxSoftBodyAttachToCollidingShapes(SB5, 0)
pxSoftBodyAttachToCollidingShapes(SB6, 0)


;   
cube = CreateCube ()
ScaleEntity cube,8,8,8
cube_body = pxBodyCreateCube(8,8,8,10)
pxBodySetPosition(cube_body,0,8,0)


While Not KeyDown( 1 )

x#=0
y#=0
z#=0
fx#=0
fy#=0
fz#=0
;  
If KeyDown( 17 ) Then fz# = 2000
If KeyDown( 31 ) Then fz# = -2000
If KeyDown( 30 ) Then fx# = -2000
If KeyDown( 32 ) Then fx# = 2000
If KeyDown( 57 ) Then fy# = 2000
pxBodyAddForce(sp_body%, fx#, fy#, fz,0)

;  
If KeyDown( 203 ) Then x#=-0.2 
If KeyDown( 205 ) Then x#=0.2 
If KeyDown( 208 ) Then y#=-0.2 
If KeyDown( 200 ) Then y#=0.2 
If KeyDown( 2 ) Then ry = ry+1
If KeyDown( 3 ) Then ry = ry-1

MoveEntity cam,x#,y#,z#

time=MilliSecs ()
pxRenderPhysic(30,0);    30,      2   ,      ;)

; 
pxUpdateSoftBody(SB1)
UpdateSoftBody(mesh1%, SB1%)

pxUpdateSoftBody(SB2)
UpdateSoftBody(mesh2%, SB2%)

pxUpdateSoftBody(SB3)
UpdateSoftBody(mesh3%, SB3%)

pxUpdateSoftBody(SB4)
UpdateSoftBody(mesh4%, SB4%)

pxUpdateSoftBody(SB5)
UpdateSoftBody(mesh5%, SB5%)

pxUpdateSoftBody(SB6)
UpdateSoftBody(mesh6%, SB6%)

New_time=MilliSecs ()-time

pxBodySetEntity(cube, cube_body)
pxBodySetEntity(sp_mesh, sp_body)

UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
  Text 10,20,"Space\W\A\S\D - Control Bubble"
  Text 10,40,"Arrow/A/Z - Move Camera"
Flip fl
Wend 

End

Function GetVertBank%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Return vbank
End Function

Function UpdateSoftBody(mesh%, SoftBody%)

	Local nvert = 0
	Local surf= GetSurface (mesh,1)
	nvert=CountVertices (surf)
	vbank=CreateBank(nvert*4*3)
	nbank=CreateBank(nvert*4*3)
	pxSoftBodyGetVertexPos(SoftBody, vbank, nvert)
	pxSoftBodyGetNormals(SoftBody, nbank, nvert)
	
	nvc=0
	For nvc = 0 To nvert - 1
		VertexCoords (surf, nvc, PeekFloat (vbank, nvc*12+0), PeekFloat(vbank, nvc*12+4), PeekFloat(vbank, nvc*12+8))
		VertexNormal (surf, nvc, PeekFloat (nbank, nvc*12+0), PeekFloat(nbank, nvc*12+4), PeekFloat(nbank, nvc*12+8))
	Next
	FreeBank vbank
	FreeBank nbank
End Function


