
Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15

;Plane
plane=CreatePlane()
text01=LoadTexture("..\media\tile.jpg")
EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,10,50,-30
RotateEntity cam,60,20,0


;PX
PxCreateWorld(1, "key")		
pxSetGravity(0,-10,0)			



For i=0 To 60
	Create_Px_Cube()
Next

trig_mesh = CreateCube()
ScaleEntity trig_mesh,2,2,10
EntityAlpha trig_mesh,0.5
trig = pxTriggerCreateCube(2, 2, 10)
pxBodySetPosition (trig,0,2,15)

trig_cu_mesh = CreateCube()
ScaleEntity trig_cu_mesh,8,2,8
EntityAlpha trig_cu_mesh,0.5
trig_cu = pxTriggerCreateCube(8, 2, 8)
pxBodySetPosition (trig_cu,15,2,-15)

trig_sp_mesh = CreateSphere()
ScaleEntity trig_sp_mesh,10, 10, 10
EntityAlpha trig_sp_mesh,0.5
trig_sp = pxTriggerCreateSphere(10)
pxBodySetPosition (trig_sp,-15,0,-15)

Repeat ;Main Loop

pxKinematicSetPosition(trig, 20*Sin(0.05*MilliSecs()),2,15)

time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Px_Cube()
pxBodySetEntity(trig_cu_mesh, trig_cu)
pxBodySetEntity(trig_sp_mesh, trig_sp)
pxBodySetEntity(trig_mesh, trig)
New_time=MilliSecs ()-time

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,20,pxTriggerGetNumBody%(trig)

Flip

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
	Field red#, green#, blue#
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

	y# = Rnd (1,2)
	x# = Rnd (1,2)
	z# = Rnd (1,2)
  ocu\cube_mesh=CreateCube ()
  ScaleMesh ocu\cube_mesh,x,y,z
  ocu\red = Rand(0,100)
  ocu\green = Rand(0,255)
  ocu\blue = Rand(0,255)
  EntityColor ocu\cube_mesh, ocu\red#, ocu\green#, ocu\blue#
  ocu\cube_body=PxBodyCreateCube(x,y,z, 10)

   pxBodySetPosition(ocu\cube_body,Rand(-25,25),Rand(20,55),Rand(-25,25))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
		If pxTriggerGetBodyTrigger(ocu\cube_body)
			EntityColor ocu\cube_mesh,255,0,0
		Else
			EntityColor ocu\cube_mesh, ocu\red#, ocu\green#, ocu\blue#
		EndIf
		  ;pxSetSleepWakeUp(ocu\cube_body, 1)
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function
