
Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0,w=1.1 ,free,in_mesh,enable=1

pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0, -10, 0)


camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,20,25,-20
RotateEntity camera,30,30,0

plane=CreatePlane( )
EntityColor plane,0,100,200

;--------------Create Trimesh----------------
free=LoadMesh ("54k.b3d")
ScaleMesh free,0.2,0.2,0.2
PositionEntity free,0,5,0

Text 10,10,"please wait while generating PhysMesh..."
Flip
GenerateTime# = MilliSecs ()
	BodyGenerateTriMesh%(free)
NewGenerateTime# =MilliSecs ()- GenerateTime
Delay 100
loadTime# = MilliSecs ()
   in_mesh=BodyCreateTriMesh()
   pxBodySetPosition(in_mesh,0,5,0)
NewLoadTime# =MilliSecs ()- loadTime

body=PxBodyCreateSphere(2, 10)
sphere= CreateSphere()
ScaleEntity sphere,2,2,2
pxBodySetPosition(body, 0,20,0)


While Not KeyDown( 1 )


If KeyHit(57)
  Create_Px_Sphere()
   k =k+1
EndIf  

time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Px_Cube()
pxBodySetEntity(sphere, body)
New_time=MilliSecs ()-time


UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,20,"Generating Time  "+NewGenerateTime/1000+" sec"
 Text 10,30,"Loading Time  "+NewLoadTime/1000+" sec"
 Text 10,40,"space - add sphere  "

Flip 
Wend 

End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type



 Function Create_Px_Sphere()
   ocu.Px_Cube = New Px_Cube

  ocu\cube_mesh=CreateSphere ()
  ScaleEntity ocu\cube_mesh,0.5,0.5,0.5 
  ocu\cube_body=PxBodyCreateSphere(0.5, 1)

   pxBodySetPosition(ocu\cube_body,3,30,0)

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Function BodyGenerateTriMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	pxCreateTriMeshToFile(vbank, fbank, nvert, nface,"Physic_mesh.px")
	FreeBank vbank
	FreeBank fbank
End Function

Function BodyCreateTriMesh%()
	bbb%=pxCreateTriMeshFromFile%("Physic_mesh.px", 0)
	Return bbb%
End Function