;Log levels
Const LOG_NO		= 5
Const LOG_FATAL		= 4
Const LOG_ERROR		= 3
Const LOG_WARNING	= 2
Const LOG_MESSAGE	= 1
Const LOG_INFO		= 0

;Log targets
Const LOG_HTML				= 1
Const LOG_COUT				= 2
Const LOG_HTML_COUT			= 3
Const LOG_STRING			= 4
Const LOG_HTML_STRING		= 5
Const LOG_COUT_STRING		= 6
Const LOG_HTML_COUT_STRING	= 7

;Skinning types
Const SKIN_HARDWARE   = 0
Const SKIN_HARDWAREVS = 1
Const SKIN_SOFTWARE   = 2

;Light sources types
Const LIGHT_DIRECTIONAL = 1
Const LIGHT_POINT       = 2
Const LIGHT_SPOT        = 3

;Texture filtering
Const TF_NONE           = 0
Const TF_POINT          = 1
Const TF_LINEAR         = 2
Const TF_ANISOTROPIC    = 3
Const TF_ANISOTROPICX4  = 4
Const TF_ANISOTROPICX8  = 5
Const TF_ANISOTROPICX16 = 6

;PixelShader versions
Const PS_1_1 = 0
Const PS_1_2 = 1
Const PS_1_3 = 2
Const PS_1_4 = 3
Const PS_2_0 = 4
Const PS_3_0 = 5

;VertexShader versions
Const VS_1_1 = 0
Const VS_2_0 = 1
Const VS_3_0 = 2

;Matrix semantics
Const WORLD                         = 0
Const WORLDVIEWPROJ                 = 1
Const VIEWPROJ                      = 2
Const VIEW                          = 3
Const PROJ                          = 4
Const WORLDVIEW                     = 5
Const VIEWINVERSE                   = 6
Const ADDITIONAL1                   = 7
Const ADDITIONAL2                   = 8
Const ADDITIONAL3                   = 9
Const ADDITIONAL4                   = 10
Const ADDITIONAL5                   = 11
Const ADDITIONAL6                   = 12
Const ADDITIONAL7                   = 13
Const ADDITIONAL8                   = 14
Const WORLDINVERSETRANSPOSE         = 15
Const WORLDINVERSE                  = 16
Const WORLDTRANSPOSE                = 17
Const VIEWPROJINVERSE               = 18
Const VIEWPROJINVERSETRANSPOSE      = 19
Const VIEWTRANSPOSE                 = 20
Const VIEWINVRSETRANSPOSE           = 21
Const PROJINVERSE                   = 22
Const PROJTRANSPOSE                 = 23
Const PROJINVRSETRANSPOSE           = 24
Const WORLDVIEWPROJTRANSPOSE        = 25
Const WORLDVIEWPROJINVERSE          = 26
Const WORLDVIEWPROJINVERSETRANSPOSE = 27
Const WORLDVIEWTRANSPOSE            = 28
Const WORLDVIEWINVERSE              = 29
Const WORLDVIEWINVERSETRANSPOSE     = 30

;Antialiasing types
Const AANONE      = 0
Const AA2SAMPLES  = 1
Const AA3SAMPLES  = 2
Const AA4SAMPLES  = 3
Const AA5SAMPLES  = 4
Const AA6SAMPLES  = 5
Const AA7SAMPLES  = 6
Const AA8SAMPLES  = 7
Const AA9SAMPLES  = 8
Const AA10SAMPLES = 9
Const AA11SAMPLES = 10
Const AA12SAMPLES = 11
Const AA13SAMPLES = 12
Const AA14SAMPLES = 13
Const AA15SAMPLES = 14
Const AA16SAMPLES = 15

; Camera fog mode
Const FOG_NONE     = 0
Const FOG_LINEAR   = 1

; Camera projection mode
Const PROJ_DISABLE		= 0
Const PROJ_PERSPECTIVE	= 1
Const PROJ_ORTHOGRAPHIC = 2

; Entity FX flags
Const FX_NOTHING		= 0
Const FX_FULLBRIGHT		= 1
Const FX_VERTEXCOLOR	= 2
Const FX_FLATSHEDED		= 4
Const FX_DISABLEFOG		= 8
Const FX_DISABLECULLING	= 16

; Entity blending modes
Const BLEND_ALPHA		= 1
Const BLEND_MULTIPLY	= 2
Const BLEND_ADD			= 3

; Compare functions
Const CMP_NEVER			= 1
Const CMP_LESS			= 2
Const CMP_EQUAL			= 3
Const CMP_LESSEQUAL		= 4
Const CMP_GREATER		= 5
Const CMP_NOTEQUAL		= 6
Const CMP_GREATEREQUAL	= 7
Const CMP_ALWAYS		= 8

; Axis
Const AXIS_X	= 1
Const AXIS_Y	= 2
Const AXIS_Z	= 3

; Texture loading flags
Const FLAGS_COLOR			= 1
Const FLAGS_ALPHA			= 2
Const FLAGS_MASKED			= 4
Const FLAGS_MIPMAPPED		= 8
Const FLAGS_CLAMPU			= 16
Const FLAGS_CLAMPV			= 32
Const FLAGS_SPHERICALENVMAP	= 64
Const FLAGS_CUBICENVMAP		= 128
Const FLAGS_R32F			= 256
Const FLAGS_RESERVED		= 512
Const FLAGS_VOLUMETEXTURE	= 1024
Const FLAGS_ARBG16F			= 2048
Const FLAGS_ARBG32F			= 4096

; Texture blending modes
Const TEXBLEND_NONE			 = 0
Const TEXBLEND_ALPHA		 = 1
Const TEXBLEND_MULTIPLY		 = 2
Const TEXBLEND_ADD			 = 3
Const TEXBLEND_DOT3			 = 4
Const TEXBLEND_LIGHTMAP		 = 5
Const TEXBLEND_SEPARATEALPHA = 6

; Cube map faces
Const FACE_LEFT		= 0
Const FACE_FORWARD	= 1
Const FACE_RIGHT	= 2
Const FACE_BACKWARD = 3
Const FACE_UP		= 4
Const FACE_DOWN		= 5

; Entity animation types
Const ANIMATION_STOP		= 0
Const ANIMATION_LOOP		= 1
Const ANIMATION_PINGPONG	= 2
Const ANIMATION_ONE			= 3

; Collision types
Const SPHERETOSHPHERE		= 1
Const SPHERETOBOX			= 2
Const SPHERETOTRIMESH		= 3

; Collision respones types
Const RESPONSE_STOP				= 1
Const RESPONSE_SLIDING			= 2
Const RESPONSE_SLIDING_DOWNLOCK	= 3

; Entity picking modes
Const PICK_NONE			= 0
Const PICK_SPHERE		= 1
Const PICK_TRIMESH		= 2
Const PICK_BOX			= 3

; Sprite view modes
Const SPRITE_FIXED		 = 1
Const SPRITE_FREE		 = 2
Const SPRITE_FREEROLL	 = 3
Const SPRITE_FIXEDYAW	 = 4

; Deferred channels types
Const DEFERRED_NONE		 = 0
Const DEFERRED_ARGB8	 = 1
Const DEFERRED_R32F		 = 2
Const DEFERRED_ARGB32F	 = 3
Const DEFERRED_GR16F	 = 4
Const DEFERRED_RGB10A2	 = 5

; X-files optimization types
Const OPTIMIZE_VERTEXCACHE	= 1
Const OPTIMIZE_STRIPREORDER = 2
Const OPTIMIZE_ATTRSORT		= 3

; Joystick types
Const JOY_NONE		= 0
Const JOY_DIGITAL	= 1
Const JOY_ANALOG	= 2

;Default font handle
Global xDefaultFont

;Vector4 type
Type Vector4D
	Field x# = 0.0, y# = 0.0, z# = 0.0, w# = 1.0
End Type

;Matrix type
Type Matrix
	Field e11# = 0.0, e12# = 0.0, e13# = 0.0, e14# = 0.0
	Field e21# = 0.0, e22# = 0.0, e23# = 0.0, e24# = 0.0
	Field e31# = 0.0, e32# = 0.0, e33# = 0.0, e34# = 0.0
	Field e41# = 0.0, e42# = 0.0, e43# = 0.0, e44# = 0.0
End Type

Function xGetTextureData%(texture%, frame% = 0)
	Return DLL_xGetTextureData%(texture%, frame%)
End Function

Function xGetTextureDataPitch%(texture%, frame% = 0)
	Return DLL_xGetTextureDataPitch%(texture%, frame%)
End Function

Function xCreateTextureFromData%(data_ptr%, width%, height%, flags% = 1 + 8, frames% = 1)
	Return DLL_xCreateTextureFromData%(data_ptr%, width%, height%, flags%, frames%)
End Function

Function xEntityType(ent%, cType%, recurse% = false)
	DLL_xEntityType(ent%, cType%, recurse%)
End Function

Function xEntityRadius(ent%, x#, y# = 0.0)
	DLL_xEntityRadius(ent%, x#, y#)
End Function

Function xFitMesh(entity%, x#, y#, z#, width#, height#, depth#, uniform% = False)
	DLL_xFitMesh(entity%, x#, y#, z#, width#, height#, depth#, uniform%)
End Function

Function xCreateEmitter%(psystem%, parent% = 0)
	Return DLL_xCreateEmitter%(psystem%, parent%)
End Function

Function xPSystemSetTexture(psystem%, texture%, frames% = 1, speed# = 0.0)
	DLL_xPSystemSetTexture(psystem%, texture%, frames%, speed#)
End Function

Function xCreatePSystem%(pointSprites% = False)
	Return DLL_xCreatePSystem%(pointSprites%)
End Function

Function xSurfaceEffectTexture(surface%, name$, texture%, frame% = 0)
	DLL_xSurfaceEffectTexture(surface%, name$, texture%, frame%)
End Function

Function xSurfaceEffectVector(surface%, name$, x#, y#, z#, w# = 1.0)
	DLL_xSurfaceEffectVector(surface%, name$, x#, y#, z#, w#)
End Function

Function xSurfaceEffectEntityTexture(surface%, name$, index% = 0)
	DLL_xSurfaceEffectEntityTexture(surface%, name$, index%)
End Function

Function xLightShadowEpsilons(light%, eps1#, eps2# = 0.16)
	DLL_xLightShadowEpsilons(light%, eps1#, eps2#)
End Function

Function xSetShadowShader(path$)
	DLL_xSetShadowShader(path$)
End Function

Function xInitShadows(dirSize% = 512, spotSize% = 512, pointSize% = 128)
	DLL_xInitShadows(dirSize%, spotSize%, pointSize%)
End Function

Function xSetShadowParams(splitPlanes% = 4, splitLambda# = 0.95, useOrtho% = True, lightDist# = 500.0)
	DLL_xSetShadowParams(splitPlanes%, splitLambda#, useOrtho%, lightDist#)
End Function

Function xInitDeferred(tex1% = 1, tex2% = 1, tex3% = 2, tex4 = 0)
	DLL_xInitDeferred(tex1%, tex2%, tex3%, tex4)
End Function

Function xSetDeferredShaders(mrtShader$, lightShader$)
	DLL_xSetDeferredShaders(mrtShader$, lightShader$)
End Function

Function xRenderWorldDeferred(texture% = 0)
	DLL_xRenderWorldDeferred(texture%)
End Function

Function xCreateLog%(target% = 1, level% = 0, filename$ = "log.html")
	Return DLL_xCreateLog(target%, level%, filename$)
end Function

Function xJoyType%(portID% = 0)
	Return DLL_xJoyType(portID)
End Function

Function xJoyDown%(key%, portID% = 0)
	Return DLL_xJoyDown(key, portID)
End Function

Function xJoyHit%(key%, portID% = 0)
	Return DLL_xJoyHit(key, portID)
End Function

Function xGetJoy%(portID% = 0)
	Return DLL_xGetJoy(portID)
End Function

Function xWaitJoy%(portID% = 0)
	Return DLL_xWaitJoy(portID)
End Function

Function xJoyX#(portID% = 0)
	Return DLL_xJoyX(portID)
End Function

Function xJoyY#(portID% = 0)
	Return DLL_xJoyY(portID)
End Function

Function xJoyZ#(portID% = 0)
	Return DLL_xJoyZ(portID)
End Function

Function xJoyU#(portID% = 0)
	Return DLL_xJoyU(portID)
End Function

Function xJoyV#(portID% = 0)
	Return DLL_xJoyV(portID)
End Function

Function xJoyPitch#(portID% = 0)
	Return DLL_xJoyPitch(portID)
End Function

Function xJoyYaw#(portID% = 0)
	Return DLL_xJoyYaw(portID)
End Function

Function xJoyRoll#(portID% = 0)
	Return DLL_xJoyRoll(portID)
End Function

Function xJoyHat#(portID% = 0)
	Return DLL_xJoyHat(portID)
End Function

Function xJoyXDir%(portID% = 0)
	Return DLL_xJoyXDir(portID)
End Function

Function xJoyYDir%(portID% = 0)
	Return DLL_xJoyYDir(portID)
End Function

Function xJoyZDir%(portID% = 0)
	Return DLL_xJoyZDir(portID)
End Function

Function xJoyUDir%(portID% = 0)
	Return DLL_xJoyUDir(portID)
End Function

Function xJoyVDir%(portID% = 0)
	Return DLL_xJoyVDir(portID)
End Function


Function xGraphics3D(width, height, depth = 16, mode = 0, vsync = 0)
	hwnd = SystemProperty("AppHWND")
	xSetWND(hwnd)
	DLL_xGraphics3D(width, height, depth, mode, vsync)
End Function

Function xText(x%, y%, dText$, cx% = 0, cy% = 0)
	DLL_xText(x%, y%, dText$, cx%, cy%)
End Function

Function xExtractAnimSeq%(ent%, ff%, fl%, seq% = 0)
	Return DLL_xExtractAnimSeq%(ent%, ff%, fl%, seq%)
End Function

Function xSetPixelShaderEntityTexture(ent%, name$, index% = 0)
	DLL_xSetPixelShaderEntityTexture(ent%, name$, index%)
End Function

Function xSetEffectEntityTexture(ent%, name$, index% = 0)
	DLL_xSetEffectEntityTexture(ent%, name$, index%)
End Function

Function xCreateListener%(parent%, rolloffFactor# = 1.0, dopplerScale# = 1.0, distanceScale# = 1.0)
	Return DLL_xCreateListener(parent%, rolloffFactor#, dopplerScale#, distanceScale#)
End Function

Function xSetEffectTexture(ent%, name$, tex%, frame% = 0)
	DLL_xSetEffectTexture(ent%, name$, tex%, frame%)
End Function

Function xSetPixelShaderTexture(ent%, name$, tex%, frame% = 0)
	DLL_xSetPixelShaderTexture(ent%, name$, tex%, frame%)
End Function

Function xLoadAnimSeq%(ent%, path$)
	Return DLL_xLoadAnimSeq%(ent%, path$)
End Function

Function xSetCubeFace(tex%, face% = 1)
	DLL_xSetCubeFace(tex%, face%)
End Function

Function xRect(x1%, y1%, x2%, y2%, solid% = 0)
	DLL_xRect(x1%, y1%, x2%, y2%, solid%)
End Function

Function xOval(x%, y%, w%, h%, solid% = 0)
	DLL_xOval(x%, y%, w%, h%, solid%)
End Function

Function xPointEntity(ent1%, ent2%, roll# = 0.0)
	DLL_xPointEntity(ent1%, ent2%, roll#)
End Function

Function xAlignToVector(ent%, x#, y#, z#, a%, f# = 1.0)
	DLL_xAlignToVector(ent%, x#, y#, z#, a%, f#)
End Function

Function xCreateCone%(seg% = 8, solid% = 1, parent% = 0)
	Return DLL_xCreateCone%(seg%, solid%, parent%)
End Function

Function xEntityX#(ent%, isGlobal% = 0)
	Return DLL_xEntityX#(ent%, isGlobal%)
End Function

Function xEntityY#(ent%, isGlobal% = 0)
	Return DLL_xEntityY#(ent%, isGlobal%)
End Function

Function xEntityZ#(ent%, isGlobal% = 0)
	Return DLL_xEntityZ#(ent%, isGlobal%)
End Function

Function xEntityRoll#(ent%, isGlobal% = 0)
	Return DLL_xEntityRoll#(ent%, isGlobal%)
End Function

Function xEntityYaw#(ent%, isGlobal% = 0)
	Return DLL_xEntityYaw#(ent%, isGlobal%)
End Function

Function xSetPostEffect(pe%, index% = 0)
	DLL_xSetPostEffect(pe%, index%)
End Function

Function xSetPostEffectVectorF(pe%, name$, x#, y#, z#, w# = 1.0)
	DLL_xSetPostEffectVector(pe%, name$, x#, y#, z#, w#)
End Function

Function xSetPostEffectVector(pe%, name$, vec.Vector4D)
	DLL_xSetPostEffectVector(pe%, name$, vec\x#, vec\y#, vec\z#, vec\w#)
End Function

Function xSetEffectVectorF(pe%, name$, x#, y#, z#, w# = 1.0)
	DLL_xSetEffectVector(pe%, name$, x#, y#, z#, w#)
End Function

Function xSetEffectVector(pe%, name$, vec.Vector4D)
	DLL_xSetEffectVector(pe%, name$, vec\x#, vec\y#, vec\z#, vec\w#)
End Function

Function xEntityPitch#(ent%, isGlobal% = 0)
	Return DLL_xEntityPitch#(ent%, isGlobal%)
End Function

Function xDrawImage(img%, x%, y%, frame% = 0)
	DLL_xDrawImage(img%, x%, y%, frame%)
End Function

Function xCreateLight%(lType% = 1)
	Return DLL_xCreateLight%(lType%)
End Function

Function xCreateSprite%(parent% = 0)
	Return DLL_xCreateSprite%(parent%)
End Function

Function xLoadSprite%(path$, flags% = 1, parent% = 0)
	Return DLL_xLoadSprite%(path$, flags%, parent%)
End Function

Function xSaveImage(img%, path$, frame% = 0)
	DLL_xSaveImage(img%, path$, frame%)
End Function

Function xRectsOverlap(rect1_X%, rect1_Y%, rect1_Width%, rect1_Height%, rect2_X%, rect2_Y%, rect2_Width%, rect2_Height%)
	Return RectsOverlap(rect1_X%, rect1_Y%, rect1_Width%, rect1_Height%, rect2_X%, rect2_Y%, rect2_Width%, rect2_Height%)
End Function

Function xLoadTerrain%(path$, parent% = 0)
	Return DLL_xLoadTerrain(path$, parent%)
End Function

Function xClearWorld(e% = 1, b% = 1, t% = 1)
	DLL_xClearWorld(e%, b%, t%)
End Function

Function xCreateMesh%(parent% = 0)
	Return DLL_xCreateMesh%(parent%)
End Function

Function xCreateSurface%(mesh%, brush% = 0, dynamic% = False)
	Return DLL_xCreateSurface%(mesh%, brush%, dynamic%)
End Function

Function xLoadBrush%(path$, flags% = 1, xs# = 1, ys# = 1)
	Return DLL_xLoadBrush(path$, flags%, xs#, ys#)
End Function

Function xAddVertex%(surf%, x#, y#, z#, u# = 0.0, v# = 0.0, w# = 0.0)
	Return DLL_xAddVertex%(surf%, x#, y#, z#, u#, v#, w#)
End Function

Function xTileImage(img%, x% = 0, y% = 0, f% = 0)
	DLL_xTileImage(img%, x%, y%, f%)
End Function

Function xVertexColor(surf%, ver%, r%, g%, b%, a# = 1.0)
	DLL_xVertexColor(surf%, ver%, r%, g%, b%, a#)
End Function

Function xVertexU#(surf%, vert%, tset% = 0)
	Return DLL_xVertexU#(surf%, vert%, tset%)
End Function

Function xVertexV#(surf%, vert%, tset% = 0)
	Return DLL_xVertexV#(surf%, vert%, tset%)
End Function

Function xVertexW#(surf%, vert%, tset% = 0)
	Return DLL_xVertexW#(surf%, vert%, tset%)
End Function

Function xClearSurface(surf%, verts% = 1, tris% = 1)
	DLL_xClearSurface(surf%, verts%, tris%)
End Function

Function xVertexTexCoords(surf%, ver%, u#, v#, w# = 0.0, tset% = 0)
	DLL_xVertexTexCoords(surf%, ver%, u#, v#, w#, tset%)
End Function

Function xCreateBrush%(r# = 255, g# = 255, b# = 255)
	Return DLL_xCreateBrush(r#, g#, b#)
End Function

Function xBrushColor(br%, r% = 255, g% = 255, b% = 255)
	DLL_xBrushColor(br%, r%, g%, b%)
End Function

Function xBrushAlpha(b%, a# = 1)
	DLL_xBrushAlpha(b%, a#)
End Function

Function xCopyMesh%(ent%, parent% = 0)
	Return DLL_xCopyMesh%(ent%, parent%)
End Function

Function xCopyEntity%(ent%, parent% = 0, cloneBuff% = 0)
	Return DLL_xCopyEntity%(ent%, parent%, cloneBuff%)
End Function

Function xCreateImage%(w%, h%, f% = 1)
	Return DLL_xCreateImage%(w%, h%, f%)
End Function

Function xLockBuffer(buf% = -1)
	DLL_xLockBuffer(buf%)
End Function

Function xUnlockBuffer(buf% = -1)
	DLL_xUnlockBuffer(buf%)
End Function

Function xImageBuffer%(img%, frame% = 0)
	Return DLL_xImageBuffer(img%, frame%)
End Function

Function xTextureBuffer%(tex%, frame% = 0)
	Return DLL_xTextureBuffer(tex%, frame%)
End Function

Function xCreateTexture%(w%, h%, fl% = 9, fr% = 1)
	Return DLL_xCreateTexture%(w%, h%, fl%, fr%)
End Function

Function xWritePixel(x%, y%, argb%, buff% = -1)
	DLL_xWritePixel(x%, y%, argb%, buff%)
End Function

Function xCopyPixel(sx%, sy%, sbuf%, dx%, dy%, dbuf% = -1)
	DLL_xCopyPixel(sx%, sy%, sbuf%, dx%, dy%, dbuf%)
End Function

Function xCopyPixelFast(sx%, sy%, sbuf%, dx%, dy%, dbuf% = -1)
	DLL_xCopyPixelFast(sx%, sy%, sbuf%, dx%, dy%, dbuf%)
End Function

Function xWritePixelFast(x%, y%, argb%, buff% = -1)
	DLL_xWritePixelFast(x%, y%, argb%, buff%)
End Function

Function xReadPixel%(x%, y%, buff% = -1)
	Return DLL_xReadPixel%(x%, y%, buff%)
End Function

Function xReadPixelFast%(x%, y%, buff% = -1)
	Return DLL_xReadPixelFast%(x%, y%, buff%)
End Function

Function xBrushShininess(b%, s# = 1)
	DLL_xBrushShininess(b%, s#)
End Function

Function xBrushBlend(b%, bm% = 1)
	DLL_xBrushBlend(b%, bm%)
End Function

Function xBrushFX(b%, fx% = 0)
	DLL_xBrushFX(b%, fx%)
End Function

Function xBrushTexture(b%, t%, f% = 0, i% = 0)
	DLL_xBrushTexture(b%, t%, f%, i%)
End Function

Function xEntityShininess(ent%, s# = 0)
	DLL_xEntityShininess(ent%, s#)
End Function

Function xModifyTerrain(ent%, x%, y%, h#, rt% = 0)
	DLL_xModifyTerrain(ent%, x%, y%, h#, rt%)
End Function
Function xCreateTerrain%(size%, parent% = 0)
	Return DLL_xCreateTerrain(size%, parent%)
End Function

Function xEntityTexture(ent%, tex%, frame% = 0, index% = 0)
	DLL_xEntityTexture(ent%, tex%, frame%, index%)
End Function

Function xDrawImageRect(img%, x%, y%, rx%, ry%, rw%, rh%, frame% = 0)
	DLL_xDrawImageRect(img%, x%, y%, rx%, ry%, rw%, rh%, frame%)
End Function

Function xEntityPickMode(ent%, Mode% = 0, obsc% = 1)
	DLL_xEntityPickMode(ent%, Mode%, obsc%)
End Function

Function xLoadFont%(font$, height% = 12, bold% = 0, italic% = 0, underline% = 0)
	Return DLL_xLoadFont(font$, height%, bold%, italic%, underline%)
End Function

Function xLinePick%(x#, y#, z#, dx#, dy#, dz#, dist# = 0.0)
	Return DLL_xLinePick%(x#, y#, z#, dx#, dy#, dz#, dist#)
End Function

Function xAnimLength#(ent%, root$ = "")
	Return DLL_xAnimLength#(ent%, root$)
End Function

Function xAnimSpeed#(entity%, rootBone$ = "")
	Return DLL_xAnimSpeed#(entity%, rootBone$)
End Function

Function xSetAnimSpeed(entity%, speed#, rootBone$ = "")
	DLL_xSetAnimSpeed(entity%, speed#, rootBone$)
End Function

Function xAnimating%(ent%, root$ = "")
	Return DLL_xAnimating%(ent%, root$)
End Function

Function xAnimTime#(ent%, root$ = "")
	Return DLL_xAnimTime#(ent%, root$)
End Function

Function xAnimSeq%(ent%, root$ = "")
	Return DLL_xAnimSeq%(ent%, root$)
End Function

Function xSetAnimTime(ent%, time#, setID% = 0, root$ = "")
	DLL_xSetAnimTime(ent%, time#, setID%, root$)
End Function

Function xSetAnimFrame(ent%, frame#, setID% = 0, root$ = "")
	DLL_xSetAnimFrame(ent%, frame#, setID%, root$)
End Function

Function xCameraProjMode(cam%, Mode% = 1)
	DLL_xCameraProjMode(cam%, Mode%)
End Function

Function xCameraFogMode(cam%, Mode% = 0)
	DLL_xCameraFogMode(cam%, Mode%)
End Function

Function xRenderWorld(twen% = 1)
	DLL_xRenderWorld(twen)
End Function

Function xUpdateWorld(speed# = 1.0)
	DLL_xUpdateWorld(speed)
End Function

Function xAnimate(ent%, mode% = 1, speed# = 1.0, seq% = 0, trans# = 0, root$ = "")
	DLL_xAnimate(ent%, mode%, speed#, seq%, trans#, root$)
End Function

Function xCreatePivot(parent% = 0)
	Return DLL_xCreatePivot(parent%)
End Function

Function xLoadAnimMesh%(path$, parent% = 0)
	Return DLL_xLoadAnimMesh(path, parent)
End Function

Function xLoadMesh%(path$, parent% = 0)
	Return DLL_xLoadMesh(path, parent)
End Function

Function xEntityParent(entity%, parent% , isglobal% = 1)
	DLL_xEntityParent(entity%, parent% , isglobal%)
End Function

Function xSetSkinningMethod(method)
	DLL_xSetSkinningMethod(method)
End Function

Function xCreateCamera%(parent% = 0)
	Return DLL_xCreateCamera(parent%)
End Function

Function xPositionEntity(ent%, x#, y#, z#, isGlobal = 0)
	DLL_xPositionEntity(ent, x, y, z, isGlobal)
End Function

Function xCreateCube%(parent% = 0)
	Return DLL_xCreateCube(parent%)
End Function

Function xCreateSphere%(seg% = 8, parent% = 0)
	Return DLL_xCreateSphere(seg%, parent%)
End Function

Function xCreateCylinder%(seg% = 8, solid% = 1, parent% = 0)
	Return DLL_xCreateCylinder(seg%, solid%, parent%)
End Function

Function xCreateTorus%(seg% = 8, parent% = 0)
	Return DLL_xCreateTorus(seg%, parent%)
End Function

Function xScaleEntity(ent%, x#, y#, z#, isGlobal = 0)
	DLL_xScaleEntity(ent, x, y, z, isGlobal)
End Function

Function xMoveEntity(ent%, x#, y#, z#, isGlobal = 0)
	DLL_xMoveEntity(ent, x, y, z, isGlobal)
End Function

Function xTranslateEntity(ent%, x#, y#, z#, isGlobal = 0)
	DLL_xTranslateEntity(ent, x, y, z, isGlobal)
End Function

Function xRotateEntity(ent%, x#, y#, z#, isGlobal = 0)
	DLL_xRotateEntity(ent, x, y, z, isGlobal)
End Function

Function xTurnEntity(ent%, x#, y#, z#, isGlobal = 0)
	DLL_xTurnEntity(ent, x, y, z, isGlobal)
End Function

Function xLoadTexture%(path$, flag% = 9)
	Return DLL_xLoadTexture(path$, flag%)
End Function

Function xGetBrushTexture%(brush%, index% = 0)
	Return DLL_xGetBrushTexture%(brush%, index%)
End Function

Function xSetVertexShaderVectorF(ent%, name$, x#, y#, z#, w# = 1.0)
	DLL_xSetVertexShaderVector(ent%, name$, x#, y#, z#, w#)
End Function

Function xSetPixelShaderVectorF(ent%, name$, x#, y#, z#, w# = 1.0)
	DLL_xSetPixelShaderVector(ent%, name$, x#, y#, z#, w#)
End Function

Function xSetVertexShaderVector(ent%, name$, vector.Vector4D)
	DLL_xSetVertexShaderVector(ent%, name$, vector\x#, vector\y#, vector\z#, vector\w#)
End Function

Function xSetPixelShaderVector(ent%, name$, vector.Vector4D)
	DLL_xSetPixelShaderVector(ent%, name$, vector\x#, vector\y#, vector\z#, vector\w#)
End Function

;Scancodes for keyboard and mouse
Const MOUSE_LEFT        = 0
Const MOUSE_RIGHT       = 1
Const MOUSE_MIDDLE      = 2
Const MOUSE4            = 3
Const MOUSE5            = 4
Const MOUSE6            = 5
Const MOUSE7            = 6
Const MOUSE8            = 7
Const KEY_ESCAPE        = 1
Const KEY_1             = 2
Const KEY_2             = 3
Const KEY_3             = 4
Const KEY_4             = 5
Const KEY_5             = 6
Const KEY_6             = 7
Const KEY_7             = 8
Const KEY_8             = 9
Const KEY_9             = 10
Const KEY_0             = 11
Const KEY_MINUS         = 12
Const KEY_EQUALS        = 13
Const KEY_BACK          = 14
Const KEY_TAB           = 15
Const KEY_Q             = 16
Const KEY_W             = 17
Const KEY_E             = 18
Const KEY_R             = 19
Const KEY_T             = 20
Const KEY_Y             = 21
Const KEY_U             = 22
Const KEY_I             = 23
Const KEY_O             = 24
Const KEY_P             = 25
Const KEY_LBRACKET      = 26
Const KEY_RBRACKET      = 27
Const KEY_RETURN        = 28
Const KEY_LCONTROL      = 29
Const KEY_RCONTROL      = 157
Const KEY_A             = 30
Const KEY_S             = 31
Const KEY_D             = 32
Const KEY_F             = 33
Const KEY_G             = 34
Const KEY_H             = 35
Const KEY_J             = 36
Const KEY_K             = 37
Const KEY_L             = 38
Const KEY_SEMICOLON     = 39
Const KEY_APOSTROPHE    = 40
Const KEY_GRAVE         = 41
Const KEY_LSHIFT        = 42
Const KEY_BACKSLASH     = 43
Const KEY_Z             = 44
Const KEY_X             = 45
Const KEY_C             = 46
Const KEY_V             = 47
Const KEY_B             = 48
Const KEY_N             = 49
Const KEY_M             = 50
Const KEY_COMMA         = 51
Const KEY_PERIOD        = 52
Const KEY_SLASH         = 53
Const KEY_RSHIFT        = 54
Const KEY_MULTIPLY      = 55
Const KEY_MENU          = 56
Const KEY_SPACE         = 57
Const KEY_F1            = 59
Const KEY_F2            = 60
Const KEY_F3            = 61
Const KEY_F4            = 62
Const KEY_F5            = 63
Const KEY_F6            = 64
Const KEY_F7            = 65
Const KEY_F8            = 66
Const KEY_F9            = 67
Const KEY_F10           = 68
Const KEY_NUMLOCK       = 69
Const KEY_SCROLL        = 70
Const KEY_NUMPAD7       = 71
Const KEY_NUMPAD8       = 72
Const KEY_NUMPAD9       = 73
Const KEY_SUBTRACT      = 74
Const KEY_NUMPAD4       = 75
Const KEY_NUMPAD5       = 76
Const KEY_NUMPAD6       = 77
Const KEY_ADD           = 78
Const KEY_NUMPAD1       = 79
Const KEY_NUMPAD2       = 80
Const KEY_NUMPAD3       = 81
Const KEY_NUMPAD0       = 82
Const KEY_DECIMAL       = 83
Const KEY_TILD          = 86
Const KEY_F11           = 87
Const KEY_F12           = 88
Const KEY_NUMPADENTER   = 156
Const KEY_RMENU         = 221
Const KEY_PAUSE         = 197
Const KEY_HOME          = 199
Const KEY_UP            = 200
Const KEY_PRIOR         = 201
Const KEY_LEFT          = 203
Const KEY_RIGHT         = 205
Const KEY_END           = 207
Const KEY_DOWN          = 208
Const KEY_NEXT          = 209
Const KEY_INSERT        = 210
Const KEY_DELETE        = 211
Const KEY_LWIN          = 219
Const KEY_RWIN          = 220
Const KEY_BACKSPACE     = KEY_BACK
Const KEY_NUMPADSTAR    = KEY_MULTIPLY
Const KEY_LALT          = 184
Const KEY_CAPSLOCK      = 58
Const KEY_NUMPADMINUS   = KEY_SUBTRACT
Const KEY_NUMPADPLUS    = KEY_ADD
Const KEY_NUMPADPERIOD  = KEY_DECIMAL
Const KEY_DIVIDE        = 181
Const KEY_NUMPADSLASH   = KEY_DIVIDE
Const KEY_RALT          = 56
Const KEY_UPARROW       = KEY_UP
Const KEY_PGUP          = KEY_PRIOR
Const KEY_LEFTARROW     = KEY_LEFT
Const KEY_RIGHTARROW    = KEY_RIGHT
Const KEY_DOWNARROW     = KEY_DOWN
Const KEY_PGDN          = KEY_NEXT
