
Graphics3D 640,480,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15

;Plane
plane=CreatePlane()
text01=LoadTexture("..\media\tile.jpg")
EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,0,40,-40
RotateEntity cam,20,0,0


;Cube
cube=CreateCube();
ScaleEntity cube,2,2,2
text02=LoadTexture("..\media\cube.jpg")
EntityTexture cube,text02


;PX
PxCreateWorld(1, "key")	
pxSetGravity(0,-10,0)	

water = pxCreateWaterCirPlane(15, 100)
pxWaterSetPosition(water, 0, 25, 0)

;Physic cube
cube_body=pxBodyCreateCube(2,2,2,10)	
pxBodySetPosition cube_body,0,58,0	

;Kep
kep = pxCreateKep%(200, 0, 1)
pxKepAddToBody(kep, cube_body)
pxKepSetLocalPosition(kep, 2, 0, 0)
pxKepSetLinearDamping(kep, 10)
pxKepSetAngularDamping(kep, 30)


sp = CreateSphere ()

;Trimesh
free_mod=LoadAnimMesh ("..\media\tubus.b3d")
free = FindChild(free_mod, "Tube") 
in_mesh=BodyCreateMesh%(free,"tybus.pm")
TrimM = pxCreateTriMeshfromPmap(in_mesh,0)


Repeat ;Main Loop


If KeyHit(2) AddCube(Rnd(-15, 15), Rnd(55, 90), Rnd(-15, 15)): k=k+1
If KeyHit(3) AddSphere(Rnd(-15, 15), Rnd(55, 90), Rnd(-15, 15)): k=k+1

PositionEntity sp, pxKepGetPosX(kep), pxKepGetPosY(kep), pxKepGetPosZ(kep)


time=MilliSecs ()
pxRenderPhysic(30,0)		
pxBodySetEntity(cube,cube_body)
pxWaterUpdate(water)
Update_Px_Cube()
New_time=MilliSecs ()-time

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()
 Text 10,10,"1 - Add cube,  2 - Add Sphere"
 Text 10,50,"FPS: "+fps1+"  dll time: "+New_time
Text 10,30,"amount  "+k
Flip

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%,cube_mesh1%
End Type

Function AddCube(px#, py#, pz#)
	cr = Rand(100,255)
	cg = Rand(50,200)
	cb = Rand(50,200)
	ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(2, 2, 2, 10)
		ocu\cube_mesh = CreateCube()
		ScaleEntity ocu\cube_mesh, 2, 2, 2
		EntityColor ocu\cube_mesh, cr, cg, cb

		buo = Rand(10,60)
		rad = 0
		height = 3
		dam = 2
		adam = 10
		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, 2, 2, 2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)
		
		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, -2, 2, 2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)

		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, 2, -2, 2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)

		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, -2, -2, 2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)

		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, 2, 2, -2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)
		
		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, -2, 2, -2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)

		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, 2, -2, -2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)

		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, -2, -2, -2)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)
		
		ax# = Rnd(-180, 180)
		ay# = Rnd(-180, 180)
		az# = Rnd(-180, 180)
		pxBodySetPosition(ocu\cube_body,px#, py#, pz#)
		pxBodySetRotation(ocu\cube_body,  ax#, ay#, az#)
		
		k=k+1
End Function

Function AddSphere(px#, py#, pz#)
	cr = Rand(100,255)
	cg = Rand(50,200)
	cb = Rand(50,200)
	ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateSphere(2, 10)
		ocu\cube_mesh = CreateSphere()
		ScaleEntity ocu\cube_mesh, 2, 2, 2
		EntityColor ocu\cube_mesh, cr, cg, cb

		buo = Rand(80,260)
		rad = 2
		height = 2
		dam = 20
		adam = 30
		kep = pxCreateKep(buo, rad, height)
		pxKepAddToBody(kep, ocu\cube_body)
		pxKepSetLocalPosition(kep, 0, 0, 0)
		pxKepSetLinearDamping(kep, dam)
		pxKepSetAngularDamping(kep, adam)
		
		ax# = Rnd(-180, 180)
		ay# = Rnd(-180, 180)
		az# = Rnd(-180, 180)
		pxBodySetPosition(ocu\cube_body,px#, py#, pz#)
		pxBodySetRotation(ocu\cube_body,  ax#, ay#, az#)
		
		k=k+1
End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function BodyCreateMesh(mesh%,file_name$)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMeshPmap(vbank, fbank, nvert, nface,f_name, 64)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function

