;**********************************************
Type Exp
	Field body
	Field mesh2
	Field mesh
	Field meshalpha#
	Field Live
End Type
;**********************************************
Type Tar
	Field shar
	Field size#
End Type
;**********************************************
;**********************************************

Global KolKUS,KolSHAR,cel=56
Global sh




Function InitPHys()
	sh=LoadAnimMesh("target2.b3d"):HideEntity sh
End Function


;**********************************************
;*************************************************
Function CreateSHAR(x#,y#,z#,siz#)
KolSHAR=KolSHAR+1
s.tar = New tar
s\shar=CopyEntity(sh)
ScaleEntity s\shar,siz#,siz#,siz#
EntityPickMode s\shar,1
EntityRadius s\shar,.1*siz# 
EntityType s\shar,cel
PositionEntity s\shar,X,Y,Z
s\size=siz
End Function
;*****************************************************
;*****************************************************
Function SelectSHAR(who)
	For s.tar=Each tar
    	If who=s\shar Then Exit
	Next
	DestroySHAR(EntityX#(s\shar,1),EntityY#(s\shar,1),EntityZ#(s\shar,1),s\size)
	FreeEntity s\shar
	Delete s
	KolSHAR=KolSHAR-1
End Function
;*****************************************************
;*****************************************************
Function DestroySHAR(x#,y#,z#,siz#)
For i=1 To 13
	KolKUS=KolKUS+1
	p.Exp = New Exp
	
	p\mesh =CopyEntity(GetChild (sh,i))
	EntityShininess p\mesh ,10
	ScaleEntity p\mesh,siz#,siz#,siz#
	PositionEntity p\mesh,x+EntityX(GetChild (sh,i)),y+EntityY(GetChild (sh,i)),z+EntityZ(GetChild (sh,i))
	p\body = PxBodyCreateCube(.1,.1,.1,.1)
	pxBodySetPosition(p\body,EntityX#(p\mesh,1),EntityY#(p\mesh,1),EntityZ#(p\mesh,1))
	p\Live=250
	p\meshalpha=1
	xx# = pxBodyGetPositionX(p\body):yy# = pxBodyGetPositionY(p\body):zz# = pxBodyGetPositionZ(p\body):	dist2# = xx*xx+yy*yy+zz*zz
	power# = 100.0
	fx# = 0;Rnd(-1,1);power*xx/dist2
	fy# = Rnd(3,9) ;power*yy/dist2
	fz# = Rnd(15,20);power*zz/dist2
	pxBodyAddForce(p\body,fx,fy,fz,0)
	power2# = 50.0
	Torque# = power2/dist2
	pxBodyAddTorque(p\body,Rnd(-Torque,Torque),Rnd(-Torque,Torque),Rnd(-Torque,Torque),0)
Next
End Function
;*************************************************************************
;*************************************************************************
Function UpdateDest()
pxRenderPhysic(60,0)
	For p.Exp = Each Exp
		PositionEntity p\mesh,pxBodyGetPositionX(p\body),pxBodyGetPositionY(p\body),pxBodyGetPositionZ(p\body)
		RotateEntity p\mesh,pxBodyGetRotationPitch(p\body),pxBodyGetRotationYaw(p\body),pxBodyGetRotationRoll(p\body)
		p\Live=p\Live-1
		If p\meshalpha<=0 Then
		pxDeleteBody(p\body)
			FreeEntity p\mesh
			Delete p
			KolKUS=KolKUS-1
		ElseIf p\Live<=0 Then
			p\meshalpha=p\meshalpha-.02
			EntityAlpha p\mesh,p\meshalpha
		EndIf
	Next
End Function

Function FreePhys()

	For p.Exp = Each Exp
			pxDeleteBody(p\body)
			FreeEntity p\mesh
			Delete p
			KolKUS=KolKUS-1
	Next


End Function


Function LevelAddMesh(mesh%)
	Local x1#,y1#,z1#,x2#,y2#,z2#,x3#,y3#,z3#
	Local ns%
	Local nsurf = CountSurfaces(mesh)
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		Local nvv = CountTriangles(surf)
		For nvc = 0 To nvv - 1
			x1# = VertexX(surf,TriangleVertex(surf,nvc,0))
			y1# = VertexY(surf,TriangleVertex(surf,nvc,0))
			z1# = VertexZ(surf,TriangleVertex(surf,nvc,0))
			
			x2# = VertexX(surf,TriangleVertex(surf,nvc,1))
			y2# = VertexY(surf,TriangleVertex(surf,nvc,1))
			z2# = VertexZ(surf,TriangleVertex(surf,nvc,1))
			
			x3# = VertexX(surf,TriangleVertex(surf,nvc,2))
			y3# = VertexY(surf,TriangleVertex(surf,nvc,2))
			z3# = VertexZ(surf,TriangleVertex(surf,nvc,2))
			
			;phLevelAddFace(x1#,y1#,z1#,x2#,y2#,z2#,x3#,y3#,z3#)
		Next
	Next
End Function