Graphics3D 800, 600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
;Global n#,k=0,w=1.1,me

pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0, -10, 0)

body=PxBodyCreateCube(7,2,5, 100)
cu= CreateCube ()
ScaleEntity cu,7,2,5
pxBodySetPosition(body, 0,10,0)
pxBodySetRotation(body, 0, 0, 0)
pxBodySetCMassLocalPosition(body, 0, -2, 0)


camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,0,35,-40
RotateEntity camera,30,0,0

plane=CreatePlane( )
EntityAlpha plane,0.9
tile2=LoadTexture("..\media\textur.bmp")
ScaleTexture tile2,5,5
EntityTexture plane,tile2


;-------------- wheel FR---------------
front_r_wheel_mesh = CreateCylinder (12)
ScaleEntity front_r_wheel_mesh,3,1,3
front_r_wheel_body = pxBodyCreateCylinder(3, 1, 16, 10)
pxBodySetPosition (front_r_wheel_body, -7,5,5)
pxBodySetRotation (front_r_wheel_body, 90,0,0)

f_r_j = pxJointCreateSuspFront(body, front_r_wheel_body, -7,5,5)
pxJointSuspSetLinLimit(f_r_j, 1)
pxJointSuspSetLinParameter(f_r_j, 1000, 10, 0.1)


;-------------- wheel FL---------------
front_l_wheel_mesh = CreateCylinder (12)
ScaleEntity front_l_wheel_mesh,3,1,3
front_l_wheel_body = pxBodyCreateCylinder(3, 1, 16, 10)
pxBodySetPosition (front_l_wheel_body, -7,5,-5)
pxBodySetRotation (front_l_wheel_body, 90,0,0)

f_l_j = pxJointCreateSuspFront(body, front_l_wheel_body, -7,5,-5)
pxJointSuspSetLinLimit(f_l_j, 1)
pxJointSuspSetLinParameter(f_l_j, 100, 1, 0.1)

;-------------- wheel BR---------------
back_r_wheel_mesh = CreateCylinder (12)
ScaleEntity back_r_wheel_mesh,3,1,3
back_r_wheel_body = pxBodyCreateCylinder(3, 1, 16, 10)
pxBodySetPosition (back_r_wheel_body, 7,5,5)
pxBodySetRotation (back_r_wheel_body, 90,0,0)

b_r_j = pxJointCreateSuspBack(body, back_r_wheel_body, 7,5,5)
pxJointSuspSetLinLimit(b_r_j, 1)
pxJointSuspSetLinParameter(b_r_j, 100, 1, 0.1)

;-------------- wheel BL---------------
back_l_wheel_mesh = CreateCylinder (12)
ScaleEntity back_l_wheel_mesh,3,1,3
back_l_wheel_body = pxBodyCreateCylinder(3, 1, 16, 10)
pxBodySetPosition (back_l_wheel_body, 7,5,-5)
pxBodySetRotation (back_l_wheel_body, 90,0,0)

b_l_j = pxJointCreateSuspBack(body, back_l_wheel_body, 7,5,-5)
pxJointSuspSetLinLimit(b_l_j, 1)
pxJointSuspSetLinParameter(b_l_j, 100, 1, 0.1)


While Not KeyDown( 1 )
PointEntity camera,cu
time=MilliSecs ()
pxRenderPhysic(60,0)
New_time=MilliSecs ()-time

;If KeyDown (57) pxAddForce(body,0,100,0, 1)
If KeyDown (205) pxBodyAddForce(body,100,0,0, 1)
If KeyDown (203) pxBodyAddForce(body,-100,0,0, 1)
If KeyDown (200) pxBodyAddForce(body,0,0,100, 1)
If KeyDown (208) pxBodyAddForce(body,0,0,-100, 1)
If KeyDown (57) pxBodyAddForce(body,0,100,0, 1)

If KeyDown (30)
angle# = angle-1
EndIf 
If KeyDown (32)
angle# = angle+1
EndIf
pxJointSuspSetAngle(f_r_j, angle)
pxJointSuspSetAngle(f_l_j, angle)
pxJointSuspSetAngle(b_r_j, angle)
pxJointSuspSetAngle(b_l_j, angle)

If KeyDown (31)
speed#=speed - 0.2
EndIf
If KeyDown (17)
speed#=speed + 0.2
EndIf
If KeyDown (57)
speed = 0
EndIf

pxBodyAddLocalTorque(front_r_wheel_body,0,   speed*100 ,0  ,2)
pxBodyAddLocalTorque (front_l_wheel_body,0,  speed*100  ,0, 2)

pxBodySetEntity(cu, body)

pxBodySetEntity(front_r_wheel_mesh, front_r_wheel_body)
pxBodySetEntity(front_l_wheel_mesh, front_l_wheel_body)
pxBodySetEntity(back_r_wheel_mesh, back_r_wheel_body)
pxBodySetEntity(back_l_wheel_mesh, back_l_wheel_body)


UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,20,"speed: "+speed+"  angle: "+angle

Flip 
Wend 

End

