
Graphics3D 640,480,32,2
SetBuffer BackBuffer()
Global fntArial=LoadFont("Arial",16)

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15

;Plane
plane=CreatePlane()
text01=LoadTexture("..\media\tile.jpg")
EntityTexture plane,text01
EntityAlpha plane,0.5


;Camera
cam=CreateCamera()
PositionEntity cam,0,40,-40
RotateEntity cam,20,0,0


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0,-30,0)

;level = LoadMesh ("..\media\002.b3d")
;PositionMesh level, 0,2,0
;ScaleMesh level,3,3,3
;surf = GetSurface (level,1)
;in_mesh=BodyCreateMesh%(level)
;
;tile2=LoadTexture("..\media\textur.bmp")
;ScaleTexture tile2,0.02,0.02
;EntityTexture level,tile2
;pxBodySetEntity(level , in_mesh)

For i=0 To 100
	Create_Px_Cube()
Next

;---------Create car------------
pobeda_mesh = LoadMesh("..\media\pobeda.b3d")
ScaleMesh pobeda_mesh,5,5,5
RotateEntity pobeda_mesh ,0,90,0
PositionEntity pobeda_mesh ,0,8,0

pobeda_phys_mesh = LoadMesh("..\media\pobeda_phys.b3d")
ScaleMesh pobeda_phys_mesh,5,5,5
RotateEntity pobeda_phys_mesh ,0,90,0
PositionEntity pobeda_phys_mesh ,0,8,0
EntityAlpha pobeda_phys_mesh,0

pobeda_body = BodyCreateHull(pobeda_phys_mesh, 100)
pxBodySetPosition (pobeda_body, 0, 15 ,0)
pxBodySetRotation (pobeda_body, 0, 90, 0)
pxBodySetCMassLocalPosition(pobeda_body, 0, -4, 0)

;------- front wheel-----------
Wheel_fr1_body = pxWheelAddToBody(pobeda_body, -4, -2, 8.5)
pxWheelSetRadius(Wheel_fr1_body,  2)
pxWheelSetSuspension(Wheel_fr1_body,  1,  200,  0.5)
wheel_fr1_mesh = LoadMesh ("..\media\pobeda_wheel.b3d")
RotateMesh wheel_fr1_mesh,0,180,0
ScaleEntity wheel_fr1_mesh,5,5,5

Wheel_fr2_body = pxWheelAddToBody(pobeda_body, 4, -2, 8.5)
pxWheelSetRadius(Wheel_fr2_body,  2)
pxWheelSetSuspension(Wheel_fr2_body,  1, 200,  0.5)
wheel_fr2_mesh = LoadMesh ("..\media\pobeda_wheel.b3d")
ScaleEntity wheel_fr2_mesh,5,5,5

;-------back wheel------------
Wheel_bac1_body = pxWheelAddToBody(pobeda_body, -4, -2, -6.5)
pxWheelSetRadius(Wheel_bac1_body,  2)
pxWheelSetSuspension(Wheel_bac1_body,  1, 200,  0.5)
wheel_bac1_mesh = LoadMesh ("..\media\pobeda_wheel.b3d")
RotateMesh wheel_bac1_mesh,0,180,0
ScaleEntity wheel_bac1_mesh,5,5,5

Wheel_bac2_body = pxWheelAddToBody(pobeda_body, 4, -2, -6.5)
pxWheelSetRadius(Wheel_bac2_body,  2)
pxWheelSetSuspension(Wheel_bac2_body,  1, 200,  0.5)
wheel_bac2_mesh =  LoadMesh ("..\media\pobeda_wheel.b3d")
ScaleEntity wheel_bac2_mesh,5,5,5

pxWheelSetFrictionToSide(Wheel_fr1_body, 50000)
pxWheelSetFrictionToSide(Wheel_fr2_body, 50000)
pxWheelSetFrictionToSide(Wheel_bac1_body, 50000)
pxWheelSetFrictionToSide(Wheel_bac2_body, 50000)


;Main Loop
Repeat

PointEntity cam, pobeda_mesh
If KeyDown (205) ang = ang+1
If KeyDown (203) ang = ang-1
If KeyDown (200) motor = motor+5
If KeyDown (208) motor = motor-5

If motor>400 motor = 400
If motor<-400 motor = -400
pxWheelSetMotorTorque(wheel_bac1_body, motor)
pxWheelSetMotorTorque(wheel_bac2_body, motor)

If ang>30 ang = 30
If ang<-30 ang = -30
	pxWheelSetSteerAngle(wheel_fr1_body,  ang)
	pxWheelSetSteerAngle(wheel_fr2_body,  ang)

	pxWheelSetBrakeTorque(wheel_bac1_body,  1)
	pxWheelSetBrakeTorque(wheel_bac2_body,  1)
	
If KeyDown (57)
	pxWheelSetBrakeTorque(wheel_bac1_body,  500)
	pxWheelSetBrakeTorque(wheel_bac2_body,  500)
	motor=0
EndIf

time=MilliSecs ()
pxRenderPhysic(60,0)		
pxBodySetEntity(pobeda_mesh, pobeda_body)

pxWheelSetEntity(wheel_fr1_mesh, wheel_fr1_body,1)
pxWheelSetEntity(wheel_fr2_mesh, wheel_fr2_body,1)
pxWheelSetEntity(wheel_bac1_mesh, wheel_bac1_body,1)
pxWheelSetEntity(wheel_bac2_mesh, wheel_bac2_body,1)

Update_Px_Cube()
New_time=MilliSecs ()-time

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()
  SetFont fntArial 
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,30,"angle= "+ang+ "  motor=  "+ motor
Flip 1

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

	y# = Rnd (1,5)
	x# = Rnd (1,5)
	z# = Rnd (1,5)
  ocu\cube_mesh=CreateCube ()
  ScaleMesh ocu\cube_mesh,x,y,z
  EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
  ocu\cube_body=PxBodyCreateCube(x,y,z, 10)

   pxBodySetPosition(ocu\cube_body,Rand(-200,200),40,Rand(-200,200))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Function BodyCreateHull%(mesh%, mass)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, mass)
	FreeBank vbank
	Return bbb
End Function

Function BodyCreateMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMesh(vbank, fbank, nvert, nface, 0)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function