Graphics3D 640,480,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
text01=LoadTexture("media\tile.jpg")
EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,0,15,-18
RotateEntity cam,20,0,0


;Cube
cube=CreateCube()
ScaleEntity cube,2,2,2
text02=LoadTexture("media\cube.jpg")
EntityTexture cube,text02

cube1=CreateCube()
syr = GetSurface (cube1,1)
ScaleEntity cube1,2,2,2
text02=LoadTexture("media\cube.jpg")
EntityTexture cube1,text02

microphone=CreateListener(cam)
bang = LoadSound ("sound_box.wav")

;PX
PxCreateWorld(1, "key")				
pxSetGravity(0,-10,0)		

;Physic cube
cube_body=pxBodyCreateSphere(2,10)	
pxBodySetPosition cube_body,0,10,0	

cube1_body=pxBodyCreateCube(20,2,20,0)		
pxBodySetPosition cube1_body,0,5,0
pxBodySetRotation cube1_body,-1,0,0	

For i = 0 To 10
	Create_Px_Cube()
Next

;pxDeleteBody(cube1_body)
Repeat ;Main Loop
If KeyHit (57) pxBodyAddForce(cube_body,0,100,0, 1)
If KeyDown (205) pxBodySetLinearSpeed(cube_body%, 3, 0, 0);pxBodyAddForce(cube_body,10,0,0, 1)
If KeyDown (203) pxBodySetLinearSpeed(cube_body%, -3, 0, 0);pxBodyAddForce(cube_body,-10,0,0, 1)
If KeyDown (200) pxBodySetLinearSpeed(cube_body%, 0, 0, 3);pxBodyAddForce(cube_body,0,0,10, 1)
If KeyDown (208) pxBodySetLinearSpeed(cube_body%, 0, 0, -3);pxBodyAddForce(cube_body,0,0,-10, 1)

If KeyDown (2) pxBodyAddForce(cube_body,0,-100,0, 0)
If KeyDown (3) pxBodyAddForce(cube_body,0,-200,0, 0)

If (pxContactGetForceN#(cube_body, 0)>1000) PlaySound(bang) 
If MouseHit(1) = True Then PlaySound(bang) ;EmitSound(bang, cube) 

ePitch# = pxBodyGetRotationPitch(cube_body)
eYaw# = pxBodyGetRotationYaw(cube_body)
eRoll# = pxBodyGetRotationRoll(cube_body)

pxRenderPhysic(100,0)
Update_Px_Cube()
pxBodySetEntity(cube,cube_body)		
pxBodySetEntity(cube1,cube1_body)


UpdateWorld()
RenderWorld()
Text 10,10,"Contact Point =  "+pxBodyGetRotationQuatX#(cube_body)
Text 10,30,"Contact Point =  "+eYaw#
Text 10,60,"Contact Point =  "+eRoll
Flip

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

	y# = Rnd (2,5)
	x# = Rnd (-5,5)
	z# = Rnd (-5,5)
  ocu\cube_mesh=CreateCube ()
  ;ScaleMesh ocu\cube_mesh,x,y,z
  EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
  ocu\cube_body=BodyCreateHull%(ocu\cube_mesh);PxCreateCube(1,1,1, 10)

   pxBodySetPosition(ocu\cube_body,Rand(-20,20),10,Rand(-20,20))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function BodyCreateHull%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, 10)
	FreeBank vbank
	Return bbb
End Function


