Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)


cu= CreateCube ()
ScaleEntity cu,6,1,6
body=PxBodyCreateCube(6,1,6, 10)
pxBodySetCMassLocalPosition(body, 0, -10, 0)
pxBodySetPosition(body, 10,30,0)

body1=PxBodyCreateCube(6,1,6, 10)
pxBodySetCMassLocalPosition(body1, 0, -10, 0)
cu1= CreateCube ()
ScaleEntity cu1,6,1,6
pxBodySetPosition(body1, -10,30,0)

joint = pxJointCreatePulley(body,body1, 15, 1, 1)
pxJointPulleySetAnchor(joint, 10,40,0,  -10,40,0)
pxJointPulleySetLocalAttachBody(joint, 0,1,0,  0,1,0)



camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,0,50,-30
RotateEntity camera,30,0,0

plane=CreatePlane( )
EntityColor plane,0,100,200



While Not KeyDown( 1 )


If KeyDown(208) pxBodyAddForce(body1, 0, 0, -40,  0)
If KeyDown(200) pxBodyAddForce(body1, 0, 0, 40,  0)
If KeyDown(203) pxBodyAddForce(body1, -40, 0, 0,  0)
If KeyDown(205) pxBodyAddForce(body1, 40, 0, 0,  0)
If KeyDown(30) pxBodyAddForce(body1, 0, 40, 0,  0)
If KeyDown(44) pxBodyAddForce(body1, 0, -40, 0,  0)

If KeyHit(2)
	 Create_Px_Cube()
EndIf  

If KeyHit(3)
	Create_Px_sphere()
EndIf  

  
time=MilliSecs ()
	pxRenderPhysic(30,0)
	pxBodySetEntity(cu, body)
	pxBodySetEntity(cu1, body1)
;	pxSetEntity( tarelka1_mesh, tarelka1_body)
;	pxSetEntity( tarelka2_mesh, tarelka2_body)
	Update_Px_Cube()
New_time=MilliSecs ()-time




UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
  Text 10,20," 2 - add Left Cube  "
  Text 10,30," 1 - add Right Cube   "

Flip 
Wend 

End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

  ocu\cube_mesh=CreateCube ()
  ocu\cube_body=PxBodyCreateCube(1,1,1, 1)

   pxBodySetPosition(ocu\cube_body,10+Rand(-3,3),40,Rand(-3,3))

 End Function

 Function Create_Px_sphere()
   ocu.Px_Cube = New Px_Cube

  ocu\cube_mesh=CreateCube ()
  ocu\cube_body=PxBodyCreateCube(1,1,1, 1)

   pxBodySetPosition(ocu\cube_body,-10-Rand(-3,3),40,Rand(-3,3))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Function BodyCreateMesh(mesh%,file_name$)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMeshPmap(vbank, fbank, nvert, nface, file_name,64 )
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function





