Graphics3D 640,480
SetBuffer BackBuffer()

;light
light=CreateLight(1)
PositionEntity light,0,50,20

;cam
campiv=CreatePivot()

cam=CreateCamera()
PositionEntity cam,0,17,-25
PointEntity cam,campiv
EntityParent cam,campiv

;plane
plane=CreatePlane()
tile1=LoadTexture("tile.jpg")
ScaleTexture tile1,5,5
EntityTexture plane,tile1

;cubic
cubic=CreateCube()
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic,tile2

cubic1=CreateCube()
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic1,tile2

;physX
pxCreateWorld(1,"{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0,-10,0)

;cube physic
xcubic=pxBodyCreateCube(1,1,1,1)
pxBodySetPosition(xcubic,0,0,0)

xcubic1=pxBodyCreateCube(1,1,1,1)
pxBodySetPosition(xcubic1,0,5,0)


Repeat

If KeyDown (205)
	pxBodyAddForce(xcubic, 40,0,0,0)
EndIf
If KeyDown (203)
	pxBodyAddForce(xcubic, -40,0,0,0)
EndIf
If KeyDown (200)
	pxBodyAddForce(xcubic, 0,0,40,0)
EndIf
If KeyDown (208)
	pxBodyAddForce(xcubic, 0,0,-40,0)
EndIf
;physic
pxRenderPhysic(30,0)

pxBodySetEntity(cubic,xcubic)
pxBodySetEntity(cubic1,xcubic1)

If KeyDown (57)
	ray=pxCreateRay()
	body  = pxRayGetBody(ray,10)
	If body pxBodyAddForce(body, 0,20,0, 1)
EndIf

UpdateWorld()
RenderWorld()
Text 5,5, "distance: "+pxRayGetDistance(0,50)
Text 5,15, "PickX:  "+pxRayGetPickX(0,50)
Text 5,25, "PickY:  "+pxRayGetPickY(0,50)
Text 5,35, "PickZ:  "+pxRayGetPickZ(0,50)
;Text 5,55, "SpeedX:  "+pxGetLinearSpeedX(xcubic)
;Text 5,65, "Speedy:  "+pxGetLinearSpeedY(xcubic)
;Text 5,75, "Speedz:  "+pxGetLinearSpeedZ(xcubic)
;Text 5,95, "VecSpeedX:  "+pxGetLinearVecSpeedX(xcubic)
;Text 5,105, "VecSpeedy:  "+pxGetLinearVecSpeedY(xcubic)
;Text 5,115, "VecSpeedz:  "+pxGetLinearVecSpeedZ(xcubic)
;Text 5,135, "Space - add force  "
Flip
Until KeyHit(1)
End