Graphics3D 640,480
SetBuffer BackBuffer()

;light
light=CreateLight(1)
PositionEntity light,0,50,20

;cam
campiv=CreatePivot()

cam=CreateCamera()
PositionEntity cam,0,7,-45
PointEntity cam,campiv
EntityParent cam,campiv

;plane
plane=CreatePlane()
tile1=LoadTexture("tile.jpg")
ScaleTexture tile1,13,13
EntityTexture plane,tile1

;cubic
cubic=CreateCube()
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,1,1
EntityTexture cubic,tile2

;physX
PxCreateWorld(1)
pxSetGravity(0,-30,0)

;cube physic
xcubic=PxCreateCube(1,1,1,0.5)
pxSetPosition(xcubic,0,20,0)
pxSetRotation(xcubic,49,21,78)
;cube mat
ping=pxCreateMaterial(xcubic)
pxMatSetRestitution(ping,1.9)

cubic2=CopyEntity(cubic)

;cube physic
xcubic2=PxCreateCube(1,1,1,0.5)
pxSetPosition(xcubic2,0,25,0)
pxSetRotation(xcubic2,56,47,65)
;cube mat
ping2=pxCreateMaterial(xcubic2)
pxMatSetRestitution(ping2,0.2)

Repeat

;physic
RenderPhysic(70)

pxSetEntity(cubic,xcubic)
pxSetEntity(cubic2,xcubic2)
;cam control
If KeyDown(200) MoveEntity cam,0,0,0.5
If KeyDown(208) MoveEntity cam,0,0,-0.5
If KeyDown(203) TurnEntity campiv,0,-3,0
If KeyDown(205) TurnEntity campiv,0,3,0

;jump
If KeyDown(57) pxAddForce(xcubic,0,99,0,0)

;cubic control
If KeyDown(17) pxAddForce(xcubic,0,0,1,1)
If KeyDown(31) pxAddForce(xcubic,0,0,-1,2)
If KeyDown(30) pxAddForce(xcubic,-1,0,0,3)
If KeyDown(32) pxAddForce(xcubic,1,0,0,3)

UpdateWorld()
RenderWorld()
Flip
Until KeyHit(1)
End