Include "GetClothFromMesh.bb"
Include "GetBodyFromMesh.bb"

Print "1 - 800x600"
Print "2 - 1024x768"
Print "3 - 1280x1024"
Print "4 - 800x600 Windowed"
key = Input()
Print "VSinc 0 or 1"
fl= Input()

If key=1 Graphics3D 800,600,32,1
If key=2 Graphics3D 1024,768,32,1
If key=3 Graphics3D 1280,1024,32,1
If key=4 Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,10,60,-15
RotateEntity light01,30,20,0


;Plane
plane=CreatePlane()
EntityColor plane,100,200,100
EntityAlpha plane, 0.5
m=CreateMirror ()

;Camera
Global cam=CreateCamera()
PositionEntity cam,30,50,-55
RotateEntity cam,30,20,0

fntArial=LoadFont("Arial",14) 
 

;PX
PxCreateWorld(1, "key")					
pxSetGravity(0,-10,0)				

 
cl_mesh = LoadAnimMesh ("demo2.b3d")
GetBodyFromMesh(cl_mesh )
GetClothFromMesh(cl_mesh)


Repeat

If KeyHit(57) Create_Px_Cube()

x#=0: y#=0: z#=0 
If KeyDown( 203 )=True Then x#=-0.2 
If KeyDown( 205 )=True Then x#=0.2 
If KeyDown( 208 )=True Then y#=-0.2 
If KeyDown( 200 )=True Then y#=0.2 
If KeyDown( 44 )=True Then z#=-0.2 
If KeyDown( 30 )=True Then z#=0.2 

MoveEntity cam,x#,y#,z#

time=MilliSecs ()
	Update_PxClothFromMesh()
	Update_Px_Cube()
	Update_PxBodyFromMesh()
	pxRenderPhysic(60,0)		
New_time=MilliSecs ()-time


If KeyHit( 2 )=True Then enable=1-enable 

WireFrame enable 
UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()
   SetFont fntArial 
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time
   Text 10,30,"space - shoot: "
   Text 10,50,"Left, Right, Up, Down, A, Z -  move camera "
Flip fl

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube
		ocu\cube_body=PxBodyCreateCube(1,1,1, 300)
 		ocu\cube_mesh=CreateCube()
		ScaleEntity ocu\cube_mesh,1,1,1
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,EntityX(cam)+Rand(-5,5),EntityY(cam)+Rand(-5,5),EntityZ(cam))
		pxBodySetRotation(ocu\cube_body,Rand(-90,90),Rand(-90,90),Rand(-90,90))

	  pxBodyAddForce(ocu\cube_body, -20, 0, 50, 2)
		
 End Function

 Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function
