Graphics3D 1024,768,32,1
SetBuffer BackBuffer() 

Include "GetCompoundFromMesh.bb"

pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")
pxSetGravity(0, -10, 0)

camera=CreateCamera()
PositionEntity camera, 110, 120, -110
RotateEntity camera, 30,30,0
light=CreateLight() 

plane =CreatePlane ()
EntityColor plane, 0,255,255
EntityAlpha plane, 0.5
;miror =CreateMirror ()


Global k
Global table = LoadAnimMesh( "table.b3d" ): HideEntity table
Global table_mesh = LoadMesh( "table.b3d" ) : HideEntity table_mesh
Global stuhl = LoadAnimMesh( "stuhl.b3d" ): HideEntity stuhl
Global stuhl_mesh = LoadMesh( "stuhl.b3d" ) : HideEntity stuhl_mesh
Global stena = LoadAnimMesh( "stena.b3d" ): HideEntity stena
Global stena_mesh = LoadMesh( "stena.b3d" ) : HideEntity stena_mesh
Global mishka = LoadAnimMesh( "mishka.b3d" ): HideEntity mishka
Global mishka_mesh = LoadMesh( "mishka.b3d" ) : HideEntity mishka_mesh
;Global slastika = LoadAnimMesh( "slastika.b3d" ): HideEntity slastika
;Global slastika_mesh = LoadMesh( "slastika.b3d" ) : HideEntity slastika_mesh
Global man = LoadAnimMesh( "man.b3d" ): HideEntity man
Global man_mesh = LoadMesh( "man.b3d" ) : HideEntity man_mesh
Global horse = LoadAnimMesh( "horse.b3d" ): HideEntity horse
Global horse_mesh = LoadMesh( "horse_mesh.b3d" ) : HideEntity horse_mesh
Global hull = LoadAnimMesh( "hull.b3d" ): HideEntity hull
Global hull_mesh = LoadMesh( "hull.b3d" ) : HideEntity hull_mesh

AddTable()
AddStuhl()
AddMishka()
AddMan()
AddHorse()

While Not KeyDown( 1 )

If KeyHit (2) AddTable()
If KeyHit (3) AddStuhl()
If KeyHit (4) AddStena()
If KeyHit (5) AddMishka()
;If KeyHit (6) AddSlastika()
If KeyHit (6) AddMan()
If KeyHit (7) AddHorse()
If KeyHit (8) AddHull()

time=MilliSecs ()
	Update_Px_Cube()
	pxRenderPhysic(30,0)
New_time=MilliSecs ()-time

UpdateWorld ()
RenderWorld ()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
   Text 10,10,"FPS: "+fps1+"  DLL Time: "+ New_time
    Text 10,20,"amount: "+k
	Text 10,30,"add body: 1..8"
Flip 1
Wend 

End

Type Px_Cube
	Field phys_body%
	Field phys_mesh%
End Type

Function AddTable()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(table, 100, 0.1)
		ocu\phys_mesh = CopyEntity (table_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(40,140), Rand(-50,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-30,30), Rand(-30,30), Rand(-30,30))
		
		k=k+1
End Function

Function AddStuhl()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(stuhl, 100, 0.1)
		ocu\phys_mesh = CopyEntity (stuhl_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(50,140), Rand(-50,140))
		pxBodySetRotation(ocu\phys_body,  Rand(-40,40), Rand(-40,40), Rand(-40,40))
		
		k=k+1
End Function

Function AddStena()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(stena, 100, 0.1)
		ocu\phys_mesh = CopyEntity (stena_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(50,140), Rand(-50,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-40,40), Rand(-40,40), Rand(-40,40))
		
		k=k+1
End Function

Function AddMishka()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(mishka, 100, 0.1)
		ocu\phys_mesh = CopyEntity (mishka_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(50,140), Rand(-40,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-40,40), Rand(-40,40), Rand(-40,40))
		
		k=k+1
End Function

Function AddSlastika()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(slastika, 100, 0.1)
		ocu\phys_mesh = CopyEntity (slastika_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(40,140), Rand(-50,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-30,30), Rand(70,120), Rand(-30,30))
		
		k=k+1
End Function

Function AddMan()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(man, 100, 0.1)
		ocu\phys_mesh = CopyEntity (man_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(40,140), Rand(-50,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-30,30), Rand(70,120), Rand(-30,30))
		
		k=k+1
End Function

Function AddHorse()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(horse, 100, 0.1)
		ocu\phys_mesh = CopyEntity (horse_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(40,140), Rand(-50,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-30,30), Rand(70,120), Rand(-30,30))
		
		k=k+1
End Function

Function AddHull()
	ocu.Px_Cube = New Px_Cube
		ocu\phys_body = GetCompoundFromMesh(hull, 100, 0.1)
		ocu\phys_mesh = CopyEntity (hull_mesh)
		EntityColor ocu\phys_mesh, Rand(255), Rand(255), Rand(255)

		pxBodySetPosition(ocu\phys_body, Rand(-50,150), Rand(40,150), Rand(-50,150))
		pxBodySetRotation(ocu\phys_body,  Rand(-130,130), Rand(170,120), Rand(-130,130))
		
		k=k+1
End Function


Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\phys_mesh, ocu\phys_body)
	Next
End Function
