Graphics3D 800, 600, 32, 2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0,capsule

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)


camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,0,20,-40
RotateEntity camera,30,0,0

plane=CreatePlane( )
EntityColor plane,0,100,200
EntityAlpha plane,0.5

mir = CreateMirror ()


cyl = pxBodyCreateCylinder( 1, 3, 8, 1)
pxBodySetPosition(cyl,0,15,0)
pxBodySetRotation(cyl,30,30,0)

cyl_mesh = CreateCylinder(8)
ScaleEntity cyl_mesh,1,3,1


While Not KeyDown( 1 )


If KeyDown(57)
	Create_Px_Cube()
	k=k+1
EndIf  

time=MilliSecs ()
	pxRenderPhysic(60,0)
	Update_Px_Cube()
New_time=MilliSecs ()-time

;pxBodySetEntity(cyl_mesh,cyl)
    PositionEntity (cyl_mesh, pxBodyGetPositionX(cyl),pxBodyGetPositionY(cyl),pxBodyGetPositionZ(cyl));
    RotateEntity (cyl_mesh, pxBodyGetRotationPitch(cyl),pxBodyGetRotationYaw(cyl),pxBodyGetRotationRoll(cyl));

UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,20,"amount: "+k
  Text 10,30,"Space - add Cylinder " 

Flip 
Wend 

End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type



 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

    ocu\cube_mesh = CreateCylinder()
	ScaleEntity ocu\cube_mesh,1,3,1
	EntityColor ocu\cube_mesh,Rand(0,255), Rand(0,255), Rand(0,255)
	
    ocu\cube_body=pxBodyCreateCylinder( 1, 3, 8, 1)

     pxBodySetPosition(ocu\cube_body,Rand(-20,20),40,Rand(-10,30))
	 pxBodySetRotation(ocu\cube_body,Rand(-50,50),Rand(-50,50),Rand(-50,50))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function BodyCreateHull%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	    Local vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, 1)
	FreeBank vbank
	Return bbb
End Function
