
Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0,w=1.1 ,sp

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

sp = LoadMesh ("media\sp.b3d")
ScaleMesh sp,.1,.1,.1

hull  = pxBodyCreateHullFromSSM(sp , 10)
pxBodySetPosition(hull,Rand(-10,20),Rand(35,50),Rand(-10,20))


camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,20,55,-50
RotateEntity camera,30,30,0

plane=CreatePlane( )
EntityColor plane,0,100,200


While Not KeyDown( 1 )


If KeyDown(57)
  Create_Hull()
   k =k+1
EndIf  
If KeyHit(2)
time1=MilliSecs ()
	Newhull=pxCopyBody(hull)
	pxBodySetPosition(Newhull,Rand(-10,20),Rand(35,50),Rand(-10,20))
	pxBodySetRotation(Newhull,0,0,180)
New_time1=MilliSecs ()-time1
EndIf  
  
time=MilliSecs ()
pxRenderPhysic(60,0)
Update_Hull()
New_time=MilliSecs ()-time

If (Newhull) pxBodySetEntity(sp1, Newhull)
pxBodySetEntity(sp, hull)

If KeyHit (17) i=i+4

UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
  Text 10,20,"    "+k
  Text 10,30,"Space - add Teapot "
Flip 
Wend 

End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


Function Create_Hull()
   ocu.Px_Cube = New Px_Cube

   ocu\cube_mesh=CopyEntity (sp)
   ocu\cube_body=BodyCreateHull(sp )
   
   pxBodySetPosition(ocu\cube_body,Rand(-10,20),Rand(35,50),Rand(-10,20))
   pxBodySetRotation(ocu\cube_body,Rand(-50,50),Rand(50,50),Rand(-50,50))
   ScaleEntity ocu\cube_mesh,1,1,1
 End Function

Function Update_Hull()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function BodyCreateHull%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, 10)
	FreeBank vbank
	Return bbb
End Function