
Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

Global StarAmount

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
text01=LoadTexture("..\media\tile.jpg")
EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,0,25,-28
RotateEntity cam,20,0,0


;Cube
cube=CreateCube()
ScaleEntity cube,2,2,2
text02=LoadTexture("..\media\cube.jpg")
EntityTexture cube,text02


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")		
pxSetGravity(0,-10,0)			

;Physic cube
cube_body=pxBodyCreateCube(2,2,2,100)		
pxBodySetPosition cube_body,10,15,0	
pxBodySetCollisionGroup(cube_body, 1)

Global pEmitter = pxParticleCreateEmitter%()
pxParticleEmitSetStartSpeed( pEmitter, 10, 20)
pxParticleEmitSetPosition(pEmitter, -25, 10,0)
pxParticleEmitSetRotation( pEmitter, 0, 0, -50)
particle_sprite = LoadSprite("..\media\star.png",2)


For i = 0 To 10
	Create_Px_Cube()
Next


Repeat ;Main Loop

 CreateParticleStar()
 
time=MilliSecs ()
pxRenderPhysic(30,0)
pxParticleUpdateEmitter(pEmitter)
Update_Px_Cube()
pxBodySetEntity(cube,cube_body)
UpdateParticleStar()
New_time=MilliSecs ()-time

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time

Flip 

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function Create_Px_Cube()
   	ocu.Px_Cube = New Px_Cube

		y# = Rnd (1,3)
		x# = Rnd (1,3)
		z# = Rnd (1,3)
	  	
		ocu\cube_mesh=CreateCube ()
	  	ScaleMesh ocu\cube_mesh,x,y,z
	  	EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
	  	ocu\cube_body=pxBodyCreateCube(x,y,z, 100)
	
   		pxBodySetPosition(ocu\cube_body,Rand(-20,30),Rand(-5,30),Rand(-10,10))
End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          	pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Type Particle_Star
	Field particle
	Field sprite
End Type

Function CreateParticleStar()
  	ps.Particle_Star = New Particle_Star
	 	ps\sprite = LoadSprite("..\media\star.png",2)
	  	ps\particle = pxParticleEmitAddParticle(pEmitter, ps\sprite)
		StarAmount = StarAmount+1
End Function

Function UpdateParticleStar()
	For ps.Particle_Star = Each Particle_Star
		If StarAmount>300
		  	entit = pxParticleEmitDeleteFirstParticle(pEmitter)
			FreeEntity Entit
			Delete ps
			StarAmount = StarAmount - 1
		  EndIf
	Next
End Function