Graphics3D 640,480,32,2
SetBuffer BackBuffer()

Global control_body = 0

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
EntityPickMode plane,2
;text01=LoadTexture("tile.jpg")
;EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,0,15,-18
RotateEntity cam,20,0,0


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")				
pxSetGravity(0,-10,0)		


For i = 0 To 20
	Create_Px_Body(Rand(1,2))
Next

point = CreateSphere ()
EntityAlpha point,0
EntityColor point,200,0,0
ScaleEntity point,0.5,0.5,0.5
ray = pxCreateRay%()

cpos_x# = 0
cpos_y# = 0
cpos_z# = 0


Repeat 

msx# = MouseXSpeed()
msy# = MouseYSpeed()

; If mouse 1 hit, create Joint and control_body
mbutton_down% = 0
If MouseHit(1)
	CameraPick(cam,MouseX(),MouseY())
	EntityAlpha point,1

    pxRaySetPosition ray,EntityX(cam,1),EntityY(cam,1), EntityZ(cam,1)
    pxRaySetDir(ray, PickedX#() - EntityX(cam,1), PickedY#() - EntityY(cam,1), PickedZ#() - EntityZ(cam,1))
	cpos_x = pxRayGetPickX(ray,1)
	cpos_y = pxRayGetPickY(ray,1)
	cpos_z = pxRayGetPickZ(ray,1)
	picked_body = pxRayGetBody(ray, 1)

	If (picked_body)
		control_body = pxBodyCreateSphere(1,10)
		pxBodySetPosition(control_body,pxRayGetPickX#(ray,1),pxRayGetPickY#(ray,1),pxRayGetPickZ#(ray,1))
		pxKinematicSet(control_body)
		pxBodySetFlagResponse(control_body, 0)
		Pick_pos_x# = cpos_x - pxBodyGetPositionX#(picked_body)
		Pick_pos_y# = cpos_y - pxBodyGetPositionY#(picked_body)
		Pick_pos_z# = cpos_z - pxBodyGetPositionZ#(picked_body)
		cJoint = pxJointCreateDistance(picked_body, control_body, Pick_pos_x, Pick_pos_y, Pick_pos_z, 0, 0, 0)
		pxJointDistanceSetPoint(cJoint, 0, 0)
		;pxJointDistanceSetSpring(cJoint,  200, 1)
	EndIf
EndIf

; Move body
If MouseDown (1)
	mbutton_down = 1
	cpos_x = cpos_x + msx/10
	cpos_y = cpos_y - msy/10
EndIf

If (control_body) pxKinematicSetPosition (control_body, cpos_x, cpos_y, cpos_z)
PositionEntity point, cpos_x, cpos_y, cpos_z

; Delete Joint and control_body
If mbutton_down = 0
	pxDeleteBody(control_body)
	control_body = 0
	pxDeleteJoint(cJoint)
	cJoint = 0
	EntityAlpha point,0
EndIf


pxRenderPhysic(30,0)
Update_Px_Body()


UpdateWorld()
RenderWorld()
Text 10,10, "Mouse 1 - drag body"
Flip

Until KeyHit(1)
End

Type Px_Body
	Field cube_body%
	Field cube_mesh%
End Type

 Function Create_Px_Body(param)
   ocu.Px_Body = New Px_Body

	y# = Rnd (2,5)
	x# = Rnd (-5,5)
	z# = Rnd (-5,5)
	If param = 1
 		 ocu\cube_mesh=CreateCube ()
 		 ocu\cube_body=PxBodyCreateCube(2,2,2, 10)
	Else
	 	 ocu\cube_mesh=CreateSphere ()
 		 ocu\cube_body=PxBodyCreateSphere(2, 10)
	EndIf
  EntityPickMode ocu\cube_mesh,2
  ScaleEntity ocu\cube_mesh,2,2,2
  EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)

   pxBodySetPosition(ocu\cube_body,Rand(-40,40),Rnd(10,20),Rand(0,50))

 End Function

Function Update_Px_Body()
	For ocu.Px_Body = Each Px_Body
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function