
Graphics3D 640,480 
SetBuffer BackBuffer() 

camera=CreateCamera() 
PositionEntity camera,100,200,-100
RotateEntity camera,30,0,0

light=CreateLight()
PositionEntity light, 10,100,-50
RotateEntity light,50,20,0 


terrain=LoadTerrain( "..\media\height_map.bmp" ) 
ScaleEntity terrain,5,50,5

grass_tex=LoadTexture( "..\media\mossyground.bmp" )
ScaleTexture grass_tex,20,20
EntityTexture terrain,grass_tex,0,1 

terra_detail=8000 
vertex_morph=True
 TerrainDetail terrain,terra_detail,vertex_morph 


;PX
pxCreateWorld(0, "{Z5e>`188i3c\]44dU18]T7c]d64el28")				
pxSetGravity(0,-10,0)	

ter# = TerrainCreate#(terrain, 5, 50, 5)

cube_me = CreateCube ()
ScaleEntity cube_me,2,2,2
cube_body = pxBodyCreateCube(2,2,2,10)
pxBodySetPosition (cube_body, 20,80,20)


WireFrame 0

For i=0 To 100
	Create_Px()
Next

While Not KeyDown( 1 ) 


; Get terrain height at marker position 
marker_y#=TerrainHeight(terrain,50,250) 


time=MilliSecs ()
	pxRenderPhysic(60,0)
	Update_Px_Cube()
	pxBodySetEntity (cube_me, cube_body)
New_time=MilliSecs ()-time

RenderWorld
frames=frames+1 
  If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time

Flip 
Wend 
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

Function TerrainCreate#(terrain%, sx, sy, sz)
     nSize% = TerrainSize (terrain)
     bank = CreateBank((nSize)*(nSize)*4)
     For z%=1 To nSize-1
          For x% = 1 To nSize-1
               Y# = TerrainHeight(terrain,x,z)
               PokeFloat bank,(z*(nSize)+x)*4,y
          Next
     Next
     body# = pxCreateTerrain(nSize,bank, sx, sy ,sz)
     FreeBank(bank)
     Return body
End Function

Function Create_Px()
   ocu.Px_Cube = New Px_Cube
  	 teapot = CreateCube ()
 ; 	 teapot = LoadMesh ("sp.b3d")
	ScaleMesh teapot,5,5,5
		ocu\cube_mesh=teapot
		ocu\cube_body=pxBodyCreateCube(5,5,5,10)
		
		EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
		pxBodySetPosition(ocu\cube_body,Rand(10,230),Rand(50,100),Rand(10,230))
		pxBodySetRotation(ocu\cube_body,Rand(-50,50),Rand(-50,50),Rand(-50,50))
		
	  kl = kl + 1
End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
	;	pxSetSleepWakeUp(ocu\cube_body, 1)
         pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function BodyCreateHull%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, 10)
	FreeBank vbank
	Return bbb
End Function