
Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15

;Plane
plane=CreatePlane()
text01=LoadTexture("..\media\tile.jpg")
EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,10,50,-30
RotateEntity cam,60,20,0

;PX
PxCreateWorld(1, "key")					
pxSetGravity(0,-10,0)				


For i=0 To 40
	Create_Px_Cube()
Next

trig_mesh = CreateCube()
ScaleEntity trig_mesh,2,2,20
EntityAlpha trig_mesh,0.5
trig = pxTriggerCreateCube(2, 2, 20)
pxBodySetPosition (trig,0,2,0)



Repeat ;Main Loop

time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Px_Cube()
pxBodySetEntity(trig_mesh, trig)
New_time=MilliSecs ()-time

rot# = rot#+.1
pxKinematicSetRotation (trig,0,rot,0)

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()
 Text 10,50,"FPS: "+fps1+"  dll time: "+New_time
Flip

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
	Field red#, green#, blue#
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

	y# = Rnd (1,2)
	x# = Rnd (1,2)
	z# = Rnd (1,2)
  ocu\cube_mesh=CreateCube ()
  ScaleMesh ocu\cube_mesh,x,y,z
  ocu\red = Rand(0,100)
  ocu\green = Rand(0,255)
  ocu\blue = Rand(0,255)
  EntityColor ocu\cube_mesh, ocu\red#, ocu\green#, ocu\blue#
  ocu\cube_body=PxBodyCreateCube(x,y,z, 10)

   pxBodySetPosition(ocu\cube_body,Rand(-25,25),30,Rand(-25,25))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
		If pxTriggerGetBodyTrigger(ocu\cube_body)
			EntityColor ocu\cube_mesh,255,0,0
		Else
			EntityColor ocu\cube_mesh, ocu\red#, ocu\green#, ocu\blue#
		EndIf
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

