
Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0,w=1.1 ,free,in_mesh

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)


camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,20,25,-20
RotateEntity camera,30,30,0

plane=CreatePlane( )
EntityColor plane,0,100,200

;--------------Create Trimesh----------------
Text 10,10,"please wait while precomputing pmap..."
Flip
free=LoadMesh ("..\media\free.b3d")
HideEntity free
   in_mesh=BodyCreateMesh%(free,"man.pm")


While Not KeyDown( 1 )

If KeyHit(57)
  Create_Px_Mesh()
   k =k+1
EndIf

If KeyDown(46)
  Create_Px_Cube()
   k =k+1
EndIf  


time=MilliSecs ()
pxRenderPhysic(60,0)
Update_Px_Cube()
New_time=MilliSecs ()-time


If KeyDown (17) i=i+4

UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
 Text 10,30," space - add trimesh   "
  Text 10,40," c - add cube   "

Flip 
Wend 

End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


Function Create_Px_Mesh()
   ocu.Px_Cube = New Px_Cube

   ocu\cube_mesh=CopyMesh (free)
   ocu\cube_body=pxCreateTriMeshFromPmap(in_mesh,10)
   pxBodySetPosition(ocu\cube_body,Rand(-10,10),Rand(15,20),Rand(-10,10))

 End Function

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

  ocu\cube_mesh=CreateCube ()
  ocu\cube_body=PxBodyCreateCube(1,1,1, 10)

   pxBodySetPosition(ocu\cube_body,Rand(-10,10),Rand(35,40),Rand(-10,10))

; pxMatSetRestitution(c,1.0)End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function


Function BodyCreateMesh(mesh%,file_name$)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMeshPmap(vbank, fbank, nvert, nface, file_name$, 64)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function
