Include "Xors3d.bb"

xGraphics3D 800,600,32,0,1
xSetBuffer xBackBuffer()
SeedRnd MilliSecs ()
Global n#,k=0,w=1.1 ,free,in_mesh,enable=0

pxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)


camera=xCreateCamera() 
light=xCreateLight()
xPositionEntity camera,20,25,-20
xRotateEntity camera,30,30,0

;plane=CreatePlane( )
;EntityColor plane,0,100,200

;--------------Create Trimesh----------------
xText 10,10,"please wait while precomputing pmap..."
xFlip
free= xLoadMesh("..\media\spring.b3d")
xScaleMesh free,0.2,0.2,0.2
xPositionEntity free,0,5,0
	in_mesh=BodyCreateMesh%(free,free)
	body=pxCreateTriMeshFromPmap(in_mesh,0)
	pxBodySetPosition(in_mesh,0,5,0)


		surf = xGetSurface(free,1)
		nft = xCountTriangles(surf)
		nvv = xCountVertices(surf)

While Not xKeyDown( 1 )


If xKeyHit(57)
  Create_Px_Sphere()
   k =k+1
EndIf  



If xKeyHit( 17 )=True Then enable=1-enable 

; Enable/disable wireframe rendering 
xWireframe enable
	  
	time=MilliSecs ()
	pxRenderPhysic(30,0)
	Update_Px_Cube()
	New_time=MilliSecs ()-time
	

	xUpdateWorld ()
	xRenderWorld
		frames=frames+1  
		If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
		xText 10,10,"FPS: "+fps1+"  dll time: "+New_time
		xText 10,20,"w -   Enable/disable wireframe rendering   "
		xText 10,30,"space - add sphere  "
	
	xFlip 
Wend 

End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


Function Create_Px_Sphere()
	ocu.Px_Cube = New Px_Cube

	ocu\cube_mesh=xCreateSphere ()
	xScaleEntity ocu\cube_mesh,0.5,0.5,0.5 
	ocu\cube_body=pxBodyCreateSphere(0.5, 1)

	pxBodySetPosition(ocu\cube_body,3,30,0)
End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
        	 pxBodySetDx9Entity ocu\cube_mesh, ocu\cube_body
	Next
End Function

Function pxBodySetDx9Entity(entity%,body%)
	xPositionEntity entity%,pxBodyGetPositionX(body%),pxBodyGetPositionY(body%),pxBodyGetPositionZ(body%)
	xRotateEntity entity%,pxBodyGetRotationPitch(body%),pxBodyGetRotationYaw(body%),pxBodyGetRotationRoll(body%)
End Function

Function BodyCreateMesh(mesh%,file_name$)
	nsurf = xCountSurfaces(mesh)-1
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = xGetSurface(mesh,ns)
		nface = nface+xCountTriangles(surf)
		nvert = nvert +xCountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	
	For ns = 1 To nsurf
		surf = xGetSurface(mesh,ns)
		nfv = xCountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,xTriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,xTriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,xTriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = xCountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,xVertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,xVertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,xVertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	
	bbb%=pxCreateTriMeshPmap(vbank, fbank, nvert, nface,file_name$,32)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function