Graphics3D 640,480,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15

;Plane
plane=CreatePlane()
text01=LoadTexture("..\media\tile.jpg")
EntityTexture plane,text01
EntityAlpha plane,0.5

m = CreateMirror ()

;Camera
cam=CreateCamera()
PositionEntity cam,0,20,-40
RotateEntity cam,20,0,0

;Cube
cube=CreateCube();
ScaleEntity cube,2,2,2
text02=LoadTexture("..\media\cube.jpg")
EntityTexture cube,text02


;PX
pxCreateWorld(1, "{Z5e>`188i3c\]44dU18]T7c]d64el28")	
pxSetGravity(0,-10,0)	

;Physic cube
cube_body=pxBodyCreateCube(2,2,2,20)	
pxBodySetPosition cube_body,0,15,0	
pxBodySetRotation cube_body,0,0,0
pxBodySetCMassLocalPosition(cube_body, 0, -4, 0)

;------- front wheel-----------
Wheel_body = pxWheelAddToBody(cube_body, -6, -2, 0)
pxWheelSetRadius(Wheel_body,  1)
pxWheelSetSuspension(Wheel_body,  2,  40,  0.5)
pxWheelSetRotation(Wheel_body,  0,  -90,  0)
wheel_mesh = CreateCube ()

;-------back wheel------------
Wheel1_body = pxWheelAddToBody(cube_body, 6, -2, 8)
pxWheelSetRadius(Wheel1_body,  1)
pxWheelSetSuspension(Wheel1_body,  2, 40,  0)
pxWheelSetRotation(Wheel1_body,  0,  -90,  0)
wheel1_mesh = CreateCube ()

Wheel2_body = pxWheelAddToBody(cube_body, 6, -2, -8)
pxWheelSetRadius(Wheel2_body,  1)
pxWheelSetSuspension(Wheel2_body,  2,  40,  0)
pxWheelSetRotation(Wheel2_body,  0,  -90,  0)
wheel2_mesh = CreateCube ()


Repeat ;Main Loop

If KeyDown (205) ang = ang+1
If KeyDown (203) ang = ang-1
If KeyDown (200) motor = motor-5
If KeyDown (208) motor = motor+5
If KeyHit (2) pxWheelDelete( wheel_body)
If KeyDown (3) pxBodyAddForce(cube_body,0,-1900,0,0)
PointEntity cam, cube


;pxWheelSetMotorTorque(wheel_body, motor)
pxWheelSetMotorTorque(wheel1_body, motor)
pxWheelSetMotorTorque(wheel2_body, motor)


	pxWheelSetBrakeTorque(wheel1_body,  1)
	pxWheelSetBrakeTorque(wheel2_body,  1)
	
If KeyDown (57)
	pxWheelSetBrakeTorque(wheel1_body,  500)
	pxWheelSetBrakeTorque(wheel2_body,  500)
	motor=0
EndIf

time=MilliSecs ()
pxRenderPhysic(60,0)		
pxBodySetEntity(cube,cube_body)
pxWheelSetEntity(wheel_mesh, wheel_body)
pxWheelSetEntity(wheel1_mesh, wheel1_body)
pxWheelSetEntity(wheel2_mesh, wheel2_body)
New_time=MilliSecs ()-time

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()

Text 10,100,"FPS: "+fps1+"  dll time: "+New_time

Flip

Until KeyHit(1)
End

