Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,40,95,-70
RotateEntity camera,30,30,0

plane=CreatePlane( )
EntityColor plane,0,100,200


main_line = CreateCylinder ()
PositionEntity main_line,0,40,0
RotateEntity main_line, 0,0,45
ScaleEntity main_line, 1,100,1
EntityColor main_line, 0,250,0

cube_body = Create_Px_Cube(4, 4, 4,   0, 40, 0,  10)
pxBodySetRotation(cube_body, 0, 0, 45)
joint = pxJointCreateCylindrical(0,cube_body,  0,40,0,  0.5,-0.5,0, -100,80)


While Not KeyDown( 1 )

If KeyHit(57)

EndIf  

If (pxBodyGetPositionY(cube_body)<8)
	pxBodyAddForce(cube_body, 0, 1200, 0, 1)
	pxBodyAddTorque(cube_body, 0, 2000, 0, 1)
EndIf

pxRenderPhysic(60,0)
Update_Px_Cube()


UpdateWorld ()
RenderWorld

Flip 
Wend 
End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


 Function Create_Px_Cube(x#, y#, z#,   pos_x#, pos_y#, pos_z#,  mass#)
   ocu.Px_Cube = New Px_Cube
  ocu\cube_mesh=CreateCube ()
  ScaleEntity ocu\cube_mesh, x, y, z
  ocu\cube_body=PxBodyCreateCube(x, y, z, mass)

   ;pxSetDamping( ocu\cube_body, 0.1, 1000)
   pxBodySetPosition(ocu\cube_body, pos_x, pos_y, pos_z)
   Return ocu\cube_body

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function




