
Graphics3D 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

PxCreateWorld(1, "key")
pxSetGravity(0, -10, 0)

camera=CreateCamera() 
light=CreateLight()
PositionEntity camera,40,95,-70
RotateEntity camera,30,30,0

plane=CreatePlane( )
EntityColor plane,0,100,200


While Not KeyDown( 1 )

If KeyHit(57)
	Create_Px_Rope(Rand(-20,20),5,Rand(-20,20),  140)
EndIf  

time=MilliSecs ()
pxRenderPhysic(30,0)
Update_Px_Cube()
New_time=MilliSecs ()-time


UpdateWorld ()
RenderWorld
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 Text 10,10,"FPS: "+fps1+"  dll time: "+New_time
Text 10,30,"space - add rope"
Flip 
Wend 
End


Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type


 Function Create_Px_Cube(x#, y#, z#,   pos_x#, pos_y#, pos_z#,  mass#)
   ocu.Px_Cube = New Px_Cube
  ocu\cube_mesh=CreateCube ()
  ScaleEntity ocu\cube_mesh, x, y, z
  ocu\cube_body=PxBodyCreateCube(x, y, z, mass)

   ;pxSetDamping( ocu\cube_body, 0.1, 1000)
   pxBodySetPosition(ocu\cube_body, pos_x, pos_y, pos_z)
   Return ocu\cube_body

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function Create_Px_Rope(pos_x, pos_y,pos_z, amount%)
	ocu.Px_Cube = New Px_Cube
 	ocu\cube_mesh = Mesh_Capsule(6, 2)
	EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
  	ocu\cube_body=pxBodyCreateCapsule(6,2, 10)
	pxBodySetPosition(ocu\cube_body, pos_x+0.1, pos_y,pos_z+0.1)

	For i=0 To amount%
	  	ocu.Px_Cube = New Px_Cube
 			ocu\cube_mesh = Mesh_Capsule(6, 2)
			EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255) 
  		 	ocu\cube_body=pxBodyCreateCapsule(6,2, 10)
		 	pos_y = pos_y+10
  		 	pxBodySetPosition(ocu\cube_body, pos_x, pos_y,pos_z)
	
			t = ocu\cube_body
			ocu= Before ocu
			joint = pxJointCreateSpherical(ocu\cube_body, t, pos_x,pos_y-5,pos_z,  0,1,0)
			pxJointSphericalSetLimitTwist(joint, -15,15,  500,0.5,0)
			pxJointSphericalSetLimitAngle(joint, 20, 0, 0)
			pxJointSphericalSetLimitSpring(joint, 500, 0.5, 0)
	Next
End Function

Function Mesh_Capsule(height#, radius#)
 ;------------------------create Mesh-------------
capsule= CreateCylinder()
ScaleMesh capsule, radius, height/2, radius
PositionMesh capsule,0,0,0

sphere1 = CreateSphere() 
ScaleMesh sphere1,radius,radius,radius
PositionMesh sphere1,0, height/2,0
AddMesh sphere1,capsule

sphere2 = CreateSphere() 
ScaleMesh sphere2,radius,radius,radius
PositionMesh sphere2,0, -height/2,0
AddMesh sphere2,capsule

FreeEntity sphere1
FreeEntity sphere2

Return capsule
;----------------------------------------------------------------
 End Function
