Graphics3D 640,480,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs ()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
text01=LoadTexture("media\tile.jpg")
EntityTexture plane,text01

;Camera
cam=CreateCamera()
PositionEntity cam,10,20,-35
RotateEntity cam,20,20,0


sp = CreateSphere ()
PositionEntity  sp, Rand(-20,20), Rand(0,20), Rand(-20,20)
EntityColor sp, 255,0,0

;PX
PxCreateWorld(1, "key")				
pxSetGravity(0,-10,0)			

;Physic cube
cube_body=pxBodyCreateCube(2,2,2,10)	
pxBodySetPosition cube_body,0,18,0		
cube=CreateCube();
ScaleEntity cube,2,2,2
text02=LoadTexture("media\cube.jpg")
EntityTexture cube,text02


For t = 1 To 30
	pos_x# = Rand(-20,20)
	pos_y# = Rand(4,20)
	pos_z# = Rand(-20,20)
	rot_x# = Rand(-200,200)
	rot_y# = Rand(-200,200)
	rot_z# = Rand(-200,200)
	
	cu_body = pxBodyCreateCube(0.5,0.5,0.5,0)
	pxBodySetPosition (cu_body, pos_x#, pos_y#, pos_z#)
	pxBodySetRotation (cu_body, rot_x#, rot_y#, rot_z#)

	cu = CreateCube()
	ScaleEntity cu,0.5,0.5,0.5
	PositionEntity cu, pos_x, pos_y, pos_z
	RotateEntity cu, rot_x, rot_y, rot_z
	EntityColor cu, Rand(0, 255), Rand(0, 255), Rand(0, 255)
Next


Repeat ;Main Loop

If (EntityDistance (sp, cube)<0.5) PositionEntity  sp, Rand(-20,20), Rand(4,20), Rand(-20,20)
pxMoveBodyToPoint(cube_body, 5 , EntityX(sp), EntityY(sp), EntityZ(sp))

pxRenderPhysic(30,0)		
pxBodySetEntity(cube,cube_body)		

UpdateWorld()
RenderWorld()

Flip

Until KeyHit(1)
pxDestroyWorld()
End