Type PxClothFromMesh
	Field physMesh_body%
	Field physMesh_mesh%
End Type

Function GetClothFromMesh(entity%)
	For i=1 To CountChildren(entity)
			child% = GetChild (entity, i)
			EntityFX child,16
			PositionEntity child, EntityX(child,1), EntityY(child,1), EntityZ(child,1)
			child_name$ = EntityName (child)
				
			If Instr(child_name$,"\cloth",1) <> 0
				cfm.PxClothFromMesh = New PxClothFromMesh
				
				child_surf = GetSurface (child,1 )
				cfm\physMesh_body = pxCreateCloth(child, child_surf )
				If  Instr(child_name$,"\thic",1) <> 0
					FirstNumber_massName% = Instr(child_name, "\thic", 1)
					LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 5)
					Lenght_massName% = LastNumber_massName - FirstNumber_massName - 5
					Last_massName$ = Mid(child_name, FirstNumber_massName+5, Lenght_massName)
					Thickness# = Float(Last_massName$)
					pxClothSetThickness (cfm\physMesh_body, Thickness)
				EndIf
				If  Instr(child_name$,"\cdam",1) <> 0
					FirstNumber_massName% = Instr(child_name, "\cdam", 1)
					LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 5)
					Lenght_massName% = LastNumber_massName - FirstNumber_massName - 5
					Last_massName$ = Mid(child_name, FirstNumber_massName+5, Lenght_massName)
					comDam# = Float(Last_massName$)
					pxClothSetComDampingCoefficient(cfm\physMesh_body, comDam)
				EndIf
				If  Instr(child_name$,"\dam",1) <> 0
					FirstNumber_massName% = Instr(child_name, "\dam", 1)
					LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 4)
					Lenght_massName% = LastNumber_massName - FirstNumber_massName - 4
					Last_massName$ = Mid(child_name, FirstNumber_massName+4, Lenght_massName)
					Dam# = Float(Last_massName$)
					pxClothSetDampingCoefficient(cfm\physMesh_body, Dam)
				EndIf
				If  Instr(child_name$,"\sstif",1) <> 0
					FirstNumber_massName% = Instr(child_name, "\sstif", 1)
					LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 6)
					Lenght_massName% = LastNumber_massName - FirstNumber_massName - 6
					Last_massName$ = Mid(child_name, FirstNumber_massName+6, Lenght_massName)
					stif# = Float(Last_massName$)
					pxClothSetStretchingStiffness#(cfm\physMesh_body, stif)
				EndIf
				If  Instr(child_name$,"\bend",1) <> 0
					FirstNumber_massName% = Instr(child_name, "\bend", 1)
					LastNumber_massName% = Instr(child_name, "\", FirstNumber_massName + 5)
					Lenght_massName% = LastNumber_massName - FirstNumber_massName - 5
					Last_massName$ = Mid(child_name, FirstNumber_massName+6, Lenght_massName)
					stif# = Float(Last_massName$)
					pxClothSetBending#(cfm\physMesh_body)
				EndIf
				If  Instr(child_name$,"\atsh",1) <> 0
					pxClothAttachToCollidingShapes(cfm\physMesh_body)
				EndIf
				cfm\physMesh_mesh = child
			EndIf
		Next

End Function

Function Update_PxClothFromMesh()
	For cfm.PxClothFromMesh = Each PxClothFromMesh
          MeshHeight cfm\physMesh_mesh
		  ;UpdateNormals cfm\physMesh_mesh
		  mSurf = GetSurface (cfm\physMesh_mesh, 1)
		  VertexCoords mSurf,0, 0,0,0
	Next
	pxUpdateCloth()
End Function
