Graphics3D 640,480,32,2
SetBuffer BackBuffer()

;Lights
light01=CreateLight()
PositionEntity light01,15,66,15
AmbientLight 255,255,255

;Plane
plane=CreatePlane()
EntityColor plane,100,0,0

;Camera
cam=CreateCamera()
PositionEntity cam,0,15,-18
RotateEntity cam,20,0,0

;sp=CreateCube ()
;ScaleEntity sp,5,5,2
;EntityAlpha sp,0.5
;PositionEntity sp,0,0,0
;RotateEntity sp,0,0,0

;Cube
cube=CreateCube()
ScaleEntity cube,2,2,2


cube1=CreateCube()
syr = GetSurface (cube1,1)
ScaleEntity cube1,2,2,2



;PX
pxCreateWorld(1,"")				;  
pxSetGravity(0,-10,0)				; 

;Physic cube
cube_body=pxBodyCreateCube(2,2,2,10)	
pxBodySetPosition cube_body,10,15,0		
;pxbodySetRotation cube_body,30,0,40	

cube1_body=pxBodyCreateCube(2,2,2,10)	
pxBodySetPosition cube1_body,0,15,0		

For i = 0 To 10
	;Create_Px_Cube()
Next

pxJointCreateFixed%(cube1_body, cube_body)

Repeat ;Main Loop

If KeyDown (57) pxBodySetLocalLinearSpeed(cube_body,0,10,0)
If KeyDown (205) pxBodySetLocalLinearSpeed(cube_body,10,0,0)
If KeyDown (203) pxBodySetLocalLinearSpeed(cube_body,-10,0,0)
If KeyDown (200) pxBodySetLocalLinearSpeed(cube_body,0,0,10)
If KeyDown (208) pxBodySetLocalLinearSpeed(cube_body,0,0,-10)

If KeyDown (2) pxBodyAddForce(cube_body,0,-100,0, 0)
If KeyDown (3) pxBodyAddForce(cube_body,0,-200,0, 0)



pxRenderPhysic(30,0)
Update_Px_Cube()
pxBodySetEntity(cube,cube_body)		
pxBodySetEntity(cube1,cube1_body)

UpdateWorld()
RenderWorld()
Text 10,10,"Contact Point =  "+pxGetContacts(cube_body)
Text 10,30,"Contact Body1 =  "+pxBodyGetLocalLinearSpeedX#(cube_body)+ " CB2 =  "+pxBodyGetLocalLinearSpeedY#(cube_body)+ " CB3 =  "+pxBodyGetLocalLinearSpeedZ#(cube_body)
Text 10,50,"Contact Force =  "+pxContactGetPointNY#(cube_body, 0);pxContactGetForceN#(cube_body, 0)
Text 10,60,"X=  "+pxContactGetForceNX#(cube_body, 0)+"  Y=  "+pxContactGetForceNY#(cube_body, 0)+"  Z=  "+pxContactGetForceNZ#(cube_body, 0)

Flip

Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

	y# = Rnd (2,5)
	x# = Rnd (-5,5)
	z# = Rnd (-5,5)
  ocu\cube_mesh=CreateCube ()
  ;ScaleMesh ocu\cube_mesh,x,y,z
  EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
  ocu\cube_body=BodyCreateHull%(ocu\cube_mesh);PxCreateCube(1,1,1, 10)

   pxBodySetPosition(ocu\cube_body,Rand(-20,20),10,Rand(-20,20))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxBodySetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function

Function BodyCreateHull%(mesh%)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, 10)
	FreeBank vbank
	Return bbb
End Function