Graphics3D 800,600,32,2
SetBuffer BackBuffer()

;light
light=CreateLight(1)
PositionEntity light,0,50,20

;cam
campiv=CreatePivot()

cam=CreateCamera()
PositionEntity cam,0,7,-15
;EntityParent cam,campiv

;plane
;plane=CreatePlane()
;tile1=LoadTexture("tile.jpg")
;ScaleTexture tile1,5,5
;EntityTexture plane,tile1

;cubic
cubic=CreateCube()
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic,tile2

;physX
PxCreateWorld(0)
pxSetGravity(0,-30,0)

level = LoadMesh ("002.b3d")
PositionMesh level, 10,1,0
CreateTrimeshMesh(level )

tile2=LoadTexture("textur.bmp")
ScaleTexture tile2,0.02,0.02
EntityTexture level,tile2

;cube physic
xcubic=PxCreateCube(1,1,1,100,10)
pxSetPosition(xcubic,0,10,0)

For i=0 To 400
	Create_Px_Cube()
Next


car = pxCreateCar(5)
pxSetCMassOffsetLocalPosition(car ,0, -0.4, 0)
car_mesh = LoadMesh("Audi.3ds")
ScaleMesh car_mesh, 0.5,0.5,0.5
RotateMesh car_mesh, 0,-90,0
PositionMesh car_mesh,0,-0.9,0


Repeat

PointEntity cam,car_mesh

pxSetEntity(cubic,xcubic)
pxSetEntity(car_mesh, car)

;car control
speed =0
If KeyDown(200) speed=1
If KeyDown(208) speed=-1

angle=0
If KeyDown(203) angle=1
If KeyDown(205) angle=-1

brake=0
If KeyDown(57) brake = 5

pxCarControl(speed, angle, brake)

;physic
RenderPhysic(60,0)
Update_Px_Cube()

UpdateWorld()
RenderWorld()
   frames=frames+1  
   If MilliSecs()-render_time=>1000  fps=frames : frames=0 : render_time=MilliSecs()  
Text 5,5,"FPS   "+fps

Flip
Until KeyHit(1)
End

Type Px_Cube
	Field cube_body%
	Field cube_mesh%
End Type

 Function Create_Px_Cube()
   ocu.Px_Cube = New Px_Cube

	y# = Rnd (0.2,1)
	x# = Rnd (0.2,1)
	z# = Rnd (0.2,1)
  ocu\cube_mesh=CreateCube ()
  ScaleMesh ocu\cube_mesh,x,y,z
  EntityColor ocu\cube_mesh,Rand(0,255),Rand(0,255),Rand(0,255)
  ocu\cube_body=PxCreateCube(x,y,z, 10, 10)

   pxSetPosition(ocu\cube_body,Rand(-40,40),40,Rand(-40,40))

 End Function

Function Update_Px_Cube()
	For ocu.Px_Cube = Each Px_Cube
          pxSetEntity(ocu\cube_mesh, ocu\cube_body)
	Next
End Function



Function CreateTrimeshMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateStaticTriMesh(vbank, fbank, nvert, nface)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function

