Graphics3D 640,480,32,2
SetBuffer BackBuffer()
;Global z#=-2.0, x#=-2.0

;light
light=CreateLight(1)
PositionEntity light,0,50,20


;plane
;plane=CreatePlane()
;tile1=LoadTexture("tile.jpg")
;ScaleTexture tile1,5,5
;EntityTexture plane,tile1

;cubic
cubic=CreateCube()
ScaleEntity cubic, 1,1,1
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic,tile2

cubic1=CreateCube()
ScaleEntity cubic1, 10,10,10
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic1,tile2

;physX
PxCreateWorld(0)
pxSetGravity(0,-10,0)

;cube physic
;xcubic = pxCreateCube(1,1,1,  1,1)
;pxSetPosition(xcubic,0,8,0)
;pxSetFrozenRotX(xcubic )
;pxSetFrozenRotZ(xcubic )

;koleso = CreateWheel(xcubic, 0, -3, 0, 1)
;cyl = CreateCylinder (12)
;RotateMesh cyl,0,0,90
;ScaleEntity cyl,.3,1,1
;PositionEntity cyl,0,5,0

xcubic1=PxCreateCube(10,10,10,  1,1)
pxSetPosition(xcubic1,0,20,0)
;pxSetFrozen(xcubic1)

terain = LoadMesh ("level.3ds")
ScaleMesh terain,15,15,15
  tri_mesh=CreateTrimeshMesh(terain)

;==============create jeep=============
jeep = LoadAnimMesh ("jeep.3ds")
PositionEntity jeep, 0,0,0
jeep_mesh = FindChild(jeep,"main") 
jeep_body =  pxCreateCube(10,4,19,  1000,.1)
pxSetPosition(jeep_body,0,15,0)
pxSetCMassOffsetLocalPosition(jeep_body, 0, -12, 0)


kol_fl = FindChild(jeep,"flw") 
kol_rl = FindChild(jeep,"rlw")
kol_fr = FindChild(jeep,"frw") 
kol_rr = FindChild(jeep,"rrw")

kol_fl_wheel  = CreateWheel(jeep_body, -11.3, -8, 11.5,  4)
kol_rl_wheel  = CreateWheel(jeep_body, 11, -8, -15.5,  4)
kol_fr_wheel  = CreateWheel(jeep_body, 11.56, -8, 11.5, 4)
kol_rr_wheel  = CreateWheel(jeep_body, -11.3, -8, -15.5, 4)

cam=CreateCamera()
PositionEntity cam,0,27,-55
RotateEntity cam,0,90,0
EntityParent cam, jeep_mesh


Repeat
PointEntity cam,jeep_mesh


If KeyDown (30)
	pxAddForce(xcubic, 0,40,0,0)
EndIf
If KeyDown (32)
	pxAddForce(xcubic, 0,40,0,0)
EndIf


If KeyDown (200)
	pxSetWheelMotorTorque(kol_rl_wheel , 5)
	pxSetWheelMotorTorque(kol_rr_wheel , 5)
	;pxSetWheelMotorTorque(kol_fl_wheel , 5)
	;pxSetWheelMotorTorque(kol_fr_wheel , 5)
EndIf
If KeyDown (208)
	pxSetWheelMotorTorque(kol_rl_wheel , -5)
	pxSetWheelMotorTorque(kol_rr_wheel , -5)
	;pxSetWheelMotorTorque(kol_fl_wheel , -5)
	;pxSetWheelMotorTorque(kol_fr_wheel , -5)
EndIf


If KeyDown (205)
angle=angle-5
	;pxSetRotation(xcubic,0,angle,0)
	;pxAddLocalTorque(xcubic, 0, 10, 0, 0)
	pxSetWheelAngle(kol_fl_wheel, 2)
	pxSetWheelAngle(kol_fr_wheel, 2)
EndIf
If KeyDown (203)
angle=angle+5
	;pxSetRotation(xcubic,0,angle,0)
	;pxAddLocalTorque(xcubic, 0, -10, 0, 0)
	pxSetWheelAngle(kol_fl_wheel, -2)
	pxSetWheelAngle(kol_fr_wheel, -2)
EndIf


;physic
RenderPhysic(50)


;pxSetEntity(cubic,xcubic)
pxSetEntity(cubic1,xcubic1)
;pxSetWheelEntity(cyl, koleso )

pxSetEntity(jeep_mesh, jeep_body)
pxSetWheelEntity(kol_fl, kol_fl_wheel )
pxSetWheelEntity(kol_rl, kol_rl_wheel )
pxSetWheelEntity(kol_fr, kol_fr_wheel )
pxSetWheelEntity(kol_rr, kol_rr_wheel )

RotateEntity kol_fl, EntityPitch(jeep_mesh,1),pxGetWheelYaw#(kol_fl_wheel),EntityRoll(jeep_mesh,1)
RotateEntity kol_fr, EntityPitch(jeep_mesh,1),pxGetWheelYaw#(kol_fr_wheel),EntityRoll(jeep_mesh,1)
RotateEntity kol_rl, EntityPitch(jeep_mesh,1),EntityYaw(jeep_mesh,1),EntityRoll(jeep_mesh,1)
RotateEntity kol_rr, EntityPitch(jeep_mesh,1),EntityYaw(jeep_mesh,1),EntityRoll(jeep_mesh,1)
a#= pxGetWheelYaw#(kol_fl_wheel)+EntityYaw(jeep_mesh,1)

UpdateWorld()
RenderWorld()
Text 5,5, "IfStartContact: "+pxGetWheelMotorTorque(kol_rl_wheel)+"   Yaw    "+a
Text 5,15, "X: "+EntityX(kol_rr,1)+"   Y:   "+EntityY(kol_rr,1)+"    Z:    "+EntityZ(kol_rr,1)


Flip
Until KeyHit(1)
End

Function CreateTrimeshMesh(mesh%)

	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateStaticTriMesh(vbank, fbank, nvert, nface)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function

