Graphics3D 640,480
SetBuffer BackBuffer()

;light
light=CreateLight(1)
PositionEntity light,0,50,20

;cam
campiv=CreatePivot()

cam=CreateCamera()
PositionEntity cam,0,7,-15
PointEntity cam,campiv
EntityParent cam,campiv

;plane
plane=CreatePlane()
tile1=LoadTexture("tile.jpg")
ScaleTexture tile1,5,5
EntityTexture plane,tile1

;cubic
cubic=CreateCube()
tile2=LoadTexture("cub.jpg")
ScaleTexture tile2,0.2,0.2
EntityTexture cubic,tile2

;physX
PxCreateWorld(1)
pxSetGravity(0,-30,0)

;cube physic
xcubic=PxCreateCube(1,1,1,1,.1)
pxSetPosition(xcubic,0,10,0)
;pxSetRotation(xcubic,45,45,45)

aniso_mat = pxCreateAnisotripicMaterial(xcubic, 0, 0, 1)


Repeat

;physic
RenderPhysic(40)

pxSetEntity(cubic,xcubic)

;cam control
If KeyDown(200) MoveEntity cam,0,0,0.5
If KeyDown(208) MoveEntity cam,0,0,-0.5
If KeyDown(203) TurnEntity campiv,0,-3,0
If KeyDown(205) TurnEntity campiv,0,3,0

;jump
If KeyDown(57) pxAddForce(xcubic,0,99,0,0)

;cubic control
If KeyDown(17) pxAddForce(xcubic,0,0,30,0)
If KeyDown(31) pxAddForce(xcubic,0,0,-30,0)
If KeyDown(30) pxAddForce(xcubic,-30,0,0,0)
If KeyDown(32) pxAddForce(xcubic,30,0,0,0)

UpdateWorld()
RenderWorld()
Text 5,5,"w,a,s,d - add side force   |   space - add vertical force   |   up,down,left,right - camera control"

Flip
Until KeyHit(1)
End